'*
'* CGI Interface. 
'* Copyright(c) 2004-2006 by Metlashevskiy Egor. All right reserved.
'*
'* CGI routines used with ForceBasic (32bit) using STDIN / STDOUT.
'*
unit Cgi

import console

declare function GetStdHandle lib "kernel32" _
    (byval nStdHandle as long) as long

declare function ReadFile lib "kernel32" _
    (byval hFile as long, _
    lpBuffer as Any, _
    byval nNumberOfBytesToRead as long, _
    lpNumberOfBytesRead as long, _
    lpOverlapped as Any) as long

Declare Function WriteFile Lib "kernel32" _
    (ByVal hFile As Long, _
    byref lpBuffer As String, _
    ByVal nNumberOfBytesToWrite As Long, _
    lpNumberOfBytesWritten As Long, _
    lpOverlapped As Any) As Long

Declare Function SetFilePointer Lib "kernel32" _
   (ByVal hFile As Long, _
   ByVal lDistanceToMove As Long, _
   lpDistanceToMoveHigh As Long, _
   ByVal dwMoveMethod As Long) As Long

Declare Function SetEndOfFile Lib "kernel32" _
   (ByVal hFile As Long) As Long

'
' Local declares
'
declare sub InitCgi()
declare sub GetFormData()
declare sub StorePairs(sData as string)
declare function GetCgiValue(cgiName as string) as string
declare sub SendHeader(sTitle as string)
declare sub Send(s as string)
declare sub SendFooter()

Public Const STD_INPUT_HANDLE = -10
Public Const STD_OUTPUT_HANDLE = -11
Public Const FILE_BEGIN = 0

' environment variables
'
Public CGI_Accept            As String
Public CGI_AuthType          As String
Public CGI_ContentLength     As String
Public CGI_ContentType       As String
Public CGI_GatewayInterface  As String
Public CGI_PathInfo          As String
Public CGI_PathTranslated    As String
Public CGI_QueryString       As String
Public CGI_Referer           As String
Public CGI_RemoteAddr        As String
Public CGI_RemoteHost        As String
Public CGI_RemoteIdent       As String
Public CGI_RemoteUser        As String
Public CGI_RequestMethod     As String
Public CGI_ScriptName        As String
Public CGI_ServerSoftware    As String
Public CGI_ServerName        As String
Public CGI_ServerPort        As String
Public CGI_ServerProtocol    As String
Public CGI_UserAgent         As String

Public lContentLength As Long   ' CGI_ContentLength converted to Long
Public hStdIn         As Long   ' handle of Standard Input
Public hStdOut        As Long   ' handle of Standard Output
Public sErrorDesc     As String ' constructed error message
Public sEmail         As String ' webmaster's/your email address
Public sFormData      As String ' url-encoded data sent by the server


sub InitCgi()
  hStdIn = GetStdHandle(STD_INPUT_HANDLE)
  hStdOut = GetStdHandle(STD_OUTPUT_HANDLE)
  CGI_Accept = Environ("HTTP_ACCEPT")
  CGI_AuthType = Environ("AUTH_TYPE")
  CGI_ContentLength = Environ("CONTENT_LENGTH")
  CGI_ContentType = Environ("CONTENT_TYPE")
  CGI_GatewayInterface = Environ("GATEWAY_INTERFACE")
  CGI_PathInfo = Environ("PATH_INFO")
  CGI_PathTranslated = Environ("PATH_TRANSLATED")
  CGI_QueryString = Environ("QUERY_STRING")
  CGI_Referer = Environ("HTTP_REFERER")
  CGI_RemoteAddr = Environ("REMOTE_ADDR")
  CGI_RemoteHost = Environ("REMOTE_HOST")
  CGI_RemoteIdent = Environ("REMOTE_IDENT")
  CGI_RemoteUser = Environ("REMOTE_USER")
  CGI_RequestMethod = Environ("REQUEST_METHOD")
  CGI_ScriptName = Environ("SCRIPT_NAME")
  CGI_ServerSoftware = Environ("SERVER_SOFTWARE")
  CGI_ServerName = Environ("SERVER_NAME")
  CGI_ServerPort = Environ("SERVER_PORT")
  CGI_ServerProtocol = Environ("SERVER_PROTOCOL")
  CGI_UserAgent = Environ("HTTP_USER_AGENT")  
  lContentLength = Val(CGI_ContentLength)
end sub

sub echo ( byval Text as string )
'dim lBytesWritten as long = 0
'dim s as string
's = Text
's = s + chr(13) + chr(10) 
prints Text
'msgbox s
'msgbox str(hStdOut)
'msgbox str(len(s))
'WriteFile (hStdOut, s, len(s), lBytesWritten, 0)
'prints "2"
end sub


sub InitLibrary()
    InitCgi()
end sub

sub ReleaseLibrary()
    echo "<br><font size=0 color=gray>"
    echo "<div style="+chr(34)+"visibility: hidden"+chr(34)+">"
end sub