'*                                                                              
'*  GRAPH.BAS - Force Basic Module                                              
'*                                                                              
'*  Copyright(c) 2004-2006 by Metlashevskiy Egor. All right reserved            
'*                                                                            
'*
'*      
'*
unit Dos.Graph

$option /r:dos4gw.rtl
 
$ifndef _GRAPH_BAS
$define _GRAPH_BAS

$ifndef _DOS4GW
  $error  'Graph'    DOS
  $error Module Graph is supported in DOS only
$endif

$include "graph.hlp"

'$include "console.bas"
'
'  
'
public enum VideoModes

   m320x200x4    = 4
   m640x200x2    = 6
   m720x350x3    = 11
   m320x200x16   = 13
   m640x200x16   = 14
   m640x350x2    = 15
   m640x350x16   = 16
   m640x480x2    = 17
   m640x480x16   = 18
   m320x200x256  = 19
   m640x400x256  = 0x100
   m640x480x256  = 0x101
   m800x600x16   = 0x102
   m800x600x256  = 0x103
   m1024x768x16  = 0x104
   m1024x768x256 = 0x105

end enum


public enum FillStyles
   gBorder = 2
   gFill   = 3    
end enum

public enum WriteModeStyles
   gOr     = 0
   gAnd    = 1
   gPreset = 2
   gPset   = 3
   gXor    = 4
end enum

public enum ClearScreenStyles
   gScreen   = 0
   gViewPort = 1
   gWindow   = 2
end enum

public enum CursorStyles
   gCursorOff = 0
   gCursorOn  = 1
end enum

public enum HorizAlignStyles
   gNormal  = 0
   gLeft    = 1
   gCenter  = 2
   gRight   = 3
end enum

public enum VertAlignStyles
   gTop     = 1
   gCap     = 2
   gHalf    = 3
   gBase    = 4
   gBottom  = 5
end enum

public enum TextPathStyles
   gPathRight = 0
   gPathLeft  = 1
   gPathUp    = 2
   gPathDown  = 3
end enum

public type VideoConfig
   NumXPixels as short
   NumYPixels as short
   NumTextCols as short
   NumTextRows as short
   NumColors as short
   BitsPerPixel as short
   NumVideoPages as short
   Mode as short
   Adapter as short
   Monitor as short
   Memory as short
end type

public type XYCoord
   x as short
   y as short
end type

'
'  
'
public sub LineTo (byval x as short, byval y as short): asm con 50: end sub
public sub Rectangle (byval x1 as short, byval y1 as short, byval x2 as short, byval y2 as short, byval FillStyle as short): asm con 51: end sub
public sub Ellipse (byval x1 as short, byval y1 as short, byval x2 as short, byval y2 as short, byval FillStyle as short): asm con 52: end sub
public sub FloodFill (byval x as short, byval y as short, byval c as short): asm con 53: end sub
public sub SetPixel (byval x as short, byval y as short): asm con 54: end sub
public sub Arc (byval x1 as short, byval y1 as short, byval x2 as short, byval y2 as short, byval x3 as short, byval y3 as short, byval p7 as short, byval p8 as short): asm con 55: end sub
public sub SetActivePage (byval Page as short): asm con 56: end sub
public sub SetVisualPage (byval Page as short): asm con 57: end sub
public function GetActivePage () as short: asm con 58: end function
public function GetVisualPage () as short: asm con 59: end function
public sub GetVideoConfig (byref Config as VideoConfig): asm con 60: end sub
public sub Polygon (byref Points(0) as XYCoord, byval NumPts as short, byval FillStyle as short): asm con 61: end sub
public function GetPixel (byval x as short, byval y as short) as short:  asm con 62: end function
public sub MoveTo (byval x as short, byval y as short): asm con 63: end sub
public sub SetFillMask (byref Mask(8) as byte): asm con 64: end sub
public sub GetFillMask (byref Mash(8) as byte): asm con 65: end sub
public sub SetLineStyle (byval LineStyle as short): asm con 66: end sub
public function GetLineStyle () as short: asm con 67: end function
public sub SetWriteMode (byval Mode as short): asm con 68: end sub
public function GetWriteMode () as short: asm con 69: end function
public sub SetViewPort (byval x1 as short, byval y1 as short, byval x2 as short, byval y2 as short): asm con 70: end sub
public sub ClearScreen (byval ClearStyle as short): asm con 71: end sub
public sub SetClipRgn (byval x1 as short, byval y1 as short, byval x2 as short, byval y2 as short): asm con 72: end sub
public sub GetClipRgn (byref x1 as short, byref y1 as short, byref x2 as short, byref y2 as short): asm con 73: end sub
public sub SetWindow (byval x1 as double, byval y1 as double, byval x2 as double, y2 as double, byval Invert as short): asm con 74: end sub
public sub DisplayCursor (byval CursorStyle as short): asm con 75: end sub
public sub OutText (byval x as short, byval y as short, byval Text as string): asm con 76: end sub
public sub SetCharSize (byval w as short, byval h as short): asm con 77: end sub
public sub SetTextAlign (byval horiz as short, byval vert as short): asm con 78: end sub
public sub SetTextPath (byval Path as short): asm con 79: end sub
public sub SetTextOrient (byval Vecx as short, byval Vecy as short): asm con 80: end sub
public sub SetCharSpacing (byval Space as short): asm con 81: end sub
public sub GetImage (byval x1 as short, byval y1 as short, byval x2 as short, byval y2 as short, byval Buffer as Pointer): asm con 82: end sub
public sub PutImage (byval x as short, byval y as short, byval Buffer as pointer, byval Mode as short): asm con 83: end sub
public function ImageSize (byval x1 as short, byval y1 as short, byval x2 as short, byval y2 as short) as long: asm con 84: end function

$endif