'*
'* Copyright(c) 2004-2006 by Metlashevskiy Egor. All right reserved.
'* E-Mail: georgy233@rambler.ru; Internet: www.forcebasic.com
'*
'*  AnsiString    .
'*          
'*        
'* ,       .
'*        
'*    (   ,   \0 )
'* AnsiString -    .  , 
'*   ,    , 
'*    . 
'*
'*  :        
'* .     -     
'*           (  ) 
'* ,     ,    
'* ,    ,    
'*  .
'*
'*  AnsiString  - .
'*
'* :    AnsiString  ,  , 
'*  .      ,   
'*    string.
'*
'*   :
'* 
'*  AnsiString () -  
'*  AnsiString (str as AnsiString ) -     
'*  AnsiString (str as string ) -       FB
'*  AnsiString (str as LPSTR ) -     LPSTR
'*  UpperCase -     
'*  LowerCase -     
'*  IsEmpty - true,   
'*  _str() -   string
'*  ToInt   -   integer
'*  ToDouble  -   double
'*  Data -    ( pointer )
'*  Length -   
'*  Size -   ,   
'*  Trim -  
'*  TrimLeft -   
'*  TrimRight -   
'*  SubString -   
'*  Insert -  
'*  Delete  -    
'*
'* :
'*  +, >, <, >=, <=, =  -   AnsiString, string
'*  :=  -  AnsiString, string, LPSTR
'*
unit lang.AnsiString


import lang.Object
import lang.StringBuffer
import windows.messagebox

'**
'* LPSTR -     
'*     . 
'*    API .
'* , :
'* declare function GetCommandLineA lib "kernel32" () as long
'*   :
'* declare function GetCommandLineA lib "kernel32" () as LPSTR
'* . GetCommandLineA     .
'* ,      AnsiString 
'*    ()  long,  LPSTR. 
'*
'*  : LPSTR                               
'*   declare function GetCommandLineA lib "kernel32" () as LPSTR
'*   dim a as AnsiString
'*   a = GetCommandLineA ()
'*   print a.c_str()
'*
'typedef LPSTR as pointer

class LPSTR 

  public data as pointer

  public operator := ( byref adr as dword ) as byte
         this.data = adr
  end function 

end class


class AnsiString: implements Object

   private ptr as pointer = NULL  '      C
   private size as dword = 0      '   
   private delta as dword = 64    '   (   )
   sub AnsiString ()
   sub AnsiString ( str as AnsiString )
   sub AnsiString ( str as string )
   sub AnsiString ( lpstr as LPSTR )
   sub ~AnsiString ()

private:

   '**
   '*    ,   
   '*
   sub _make_ptr ( size as dword )
       if (ptr <> NULL)  then
        '     ,    
        if (this.size >= size) then
        else                            
          dim nptr as pointer
          nptr = malloc (size+1)
          strcpy (nptr, this.ptr)
          mfree (this.ptr)
          this.ptr = nptr
          this.size = size
        end if  
       else  
          '    NULL (    )
          ptr = malloc ( size+1 )
          this.size = size 
       end if
   end sub

   '**
   '*  ,   
   '*
   sub _free_ptr ()
       if ptr <> NULL then mfree ( ptr )
   end sub

   '**
   '*  ptrstr -   (string)   ForceBasic.
   '*  Address -       '\0'.
   '*          DLL, 
   '*      .
   '*
   function ptrstr ( byval Address as LPSTR ) as boolean
       if this.ptr <> NULL then
          mfree( this.ptr )
       end if
       this.ptr = VirtualOf ( Address.data )
       this.size = strlen (this.ptr)
   end function

public:

   function IsEmpty () as boolean
       return = ( this.ptr = NULL )
   end function

   '**
   '*     ForceBasic 
   '*
   operator := ( byref str as string ) as byte
      this._make_ptr ( Len(str) )
      strcpy (this.ptr, str)
   end function
   
   '**
   '*  AnsiString
   '*
   operator := ( byref a_str as AnsiString ) as byte
      if a_str.ptr <> NULL then
       this._make_ptr ( a_str.size )
       strcpy (this.ptr, a_str.ptr )
      end if 
   end function
   
   '**
   '*  LPSTR
   '*
   operator := ( byref lpstr as LPSTR ) as byte
       this.ptrstr ( lpstr )
   end function
   '**
   '*   
   '*
   operator + ( byref str as string ) as AnsiString
      if this.ptr <> NULL then
         return._make_ptr (this.size + Len(str))
         strcpy (return.ptr, this.ptr)
         strcat (return.ptr, str)
      end if
   end function
  
   operator + ( byref a_str as AnsiString ) as AnsiString
      if (this.ptr <> NULL) and (a_str.ptr <> NULL) then
         return._make_ptr (this.size + a_str.size)
         strcpy (return.ptr, this.ptr)
         strcat (return.ptr, a_str.ptr)
      end if
   end function
   
   '**
   '*  
   '*
   operator = ( byref a_str as AnsiString ) as boolean
       return = false
       if (this.ptr <> NULL) and (a_str.ptr <> NULL) then
          return =  ( strcoll (this.ptr, a_str.ptr) = 0 )
       end if
   end function
   operator = ( byref str as string ) as boolean
       return = false
       if this.ptr <> NULL then
          dim a as AnsiString
          a = str
          return = ( this = a )
       end if 
   end function

   '**
   '*   AnsiString
   '*
   operator > ( byref a_str as AnsiString ) as boolean
       return = false
       if this.ptr <> NULL then
          return =  ( strcoll (this.ptr, a_str.ptr) > 0 )
       end if 
   end function

   operator < ( byref a_str as AnsiString ) as boolean
       return = false
       if this.ptr <> NULL then
          return =  ( strcoll (this.ptr, a_str.ptr) < 0 )
       end if 
   end function
   
   operator <= ( byref a_str as AnsiString ) as boolean
       return = false
       if this.ptr <> NULL then
          return =  ( strcoll (this.ptr, a_str.ptr) <= 0 )
       end if 
   end function

   operator >= ( byref a_str as AnsiString ) as boolean
       return = false
       if this.ptr <> NULL then
          return =  ( strcoll (this.ptr, a_str.ptr) >= 0 )
       end if 
   end function
   
   '**
   '*   string
   '*
   operator > ( byref str as string ) as boolean
       return = false
       if this.ptr <> NULL then
          dim a as AnsiString
          a = str
          return = ( this > a ) 
       end if
   end function
   
   operator < ( byref str as string ) as boolean
       return = false
       if this.ptr <> NULL then
          dim a as AnsiString
          a = str
          return = ( this < a ) 
       end if
   end function
   
   operator >= ( byref str as string ) as boolean
       return = false
       if this.ptr <> NULL then
          dim a as AnsiString
          a = str
          return = ( this >= a ) 
       end if
   end function
   
   operator <= ( byref str as string ) as boolean
       return = false
       if this.ptr <> NULL then
          dim a as AnsiString
          a = str
          return = ( this <= a ) 
       end if
   end function
   
   '**
   '*    
   '*
   function LowerCase () as AnsiString
       return = this
       strlwr (return.ptr)
   end function

   '**
   '*    
   '*
   function UpperCase () as AnsiString
       return = this
       strupr (return.ptr)
   end function
   
   '**
   '*       ForceBasic
   '*
   function c_str () as string
     if this.ptr <> NULL then
       return = CharToStr (this.ptr)
     else
       return = ""
     end if  
   end function

   '**
   '*     . 
   '*
   function ToInt () as integer
     return = 0
     if this.ptr <> NULL then
       return = val ( this.c_str() )
     end if  
   end function
   
   function ToDouble () as double
     return = 0
     if this.ptr <> NULL then
        return = val ( this.c_str() )
     end if
   end function
   
   '**
   '*    .
   '* !      this.ptr 
   '*               .
   '*
   function Data () as pointer
        return = this.ptr
   end function
   
   '**
   '*   .
   '*
   function Length () as dword
        if this.ptr <> NULL then
           return = strlen (this.ptr)
        end if
   end function
   
   '**
   '*      
   '*
   function Size () as dword
        return = this.size
   end function
   
   '**
   '*   .
   '*
   function SubString ( byval Index as integer, byval Count as integer ) as AnsiString
      if this.ptr <> NULL then
         dim s as string
         s = mid$ (CharToStr(this.ptr), Index, Count)
         return = s
      end if
   end function
   
   '**
   '*    . Trim - , TrimLeft - .....
   '*
   function Trim () as AnsiString
      if this.ptr <> NULL then
         return = Trim$(CharToStr(this.ptr))
      end if
   end function
   
   function TrimLeft () as AnsiString
      if this.ptr <> NULL then
         return = LTrim$(CharToStr(this.ptr))
      end if
   end function

   function TrimRight () as AnsiString
      if this.ptr <> NULL then
         return = RTrim$(CharToStr(this.ptr))
      end if
   end function
   
   '**
   '*    
   '*
   function Insert ( a_str as AnsiString, byval Index as integer ) as AnsiString
      if (this.ptr <> NULL) and (a_str.ptr <> NULL) then
         return = (this.SubString(0, Index).c_str()) + a_str.c_str() + (this.SubString (Index, this.Length()).c_str())
      end if
   end function 

   '**
   '*    
   '*
   function Delete ( byval Index as integer, byval Count as integer ) as AnsiString
       if this.ptr <> NULL then
          return = this.SubString(0, Index) + this.SubString (Index+Count, this.Length())
       end if
   end function 

   function Explode ( byref sb as AnsiString, byval separator as string ) as StringBuffer
       return = explode (sb.c_str, separator)
   end function

end class

sub AnsiString.~AnsiString ()
    if this.ptr <> NULL then
        mfree this.ptr
    end if
end sub

sub AnsiString.AnsiString ()
end sub

sub AnsiString.AnsiString ( str as AnsiString )
    this = str  '   := (),  AnsiString
end sub

sub AnsiString.AnsiString ( str as string )
    this = str  '   := (),  string
end sub

sub AnsiString.AnsiString ( lpstr as LPSTR )
    this.ptrstr ( lpstr )
end sub