'*
'* Classes.bas - Dynamic Classes 
'* 
'* Copyright(c) 2004-2006 by Metlashevskiy Egor. All right reserved  
'*
unit lang.Classes

import lang.Object
import lang.Collection
import windows.messagebox

$document "../../../doc/Classes.htm"

enum PropertyTypes
     ptTypeData = 0
     ptObject = 1
     ptLinkObject = 2
end enum

private local_ad as dword
private local_rc as dword
private local_sc as dword


class PropertyInfo: implements Object
public:
      dim Name as string
      dim DataType as string
      dim TypeKind as PropertyTypes
      dim GetPropAddr as pointer
      dim PutPropAddr as pointer
      '
      '    .
      '
      declare function GetValue ( byref Obj as Object ) as string


      '
      '    .
      '
      declare function SetValue ( byref Obj as Object, byval Value as string ) as string

      sub PropertyInfo ()

end class

sub PropertyInfo.PropertyInfo ()
    this.TypeKind = ptTypeData
    this.GetPropAddr = null
    this.PutPropAddr = null
end sub

class EventInfo: implements Object

     dim Name as string
     dim OffsetInClass as dword
     dim DeclareText as string

end class

'**
'*
'*  ClassInfo    
'* published ,  
'*
'*
class ClassInfo: implements Object

public:
      dim Name as string
      dim ImplementClass as string
      dim Propertys as Collection
      dim Events as Collection

      dim CreateCtrlAddr as pointer
      dim ClassSize as dword

      '     (  PropertyInfo)   
      declare function GetPropertyFromNameClass ( byval PropertyName as string, byval ClassName as string ) as pointer
      declare function GetPropertyFromName ( byval PropertyName as string ) as pointer
      
      '  true,    ClassName 
      declare function isImplement ( byval ClassName as string ) as boolean
      declare sub GetEventsInfo ( byref EventCol as Collection )
      declare sub GetEventsInfo ( byval ClassName as string, byref EventCol as Collection )

      sub ClassInfo ()

      sub ~ClassInfo ()
end class


sub ClassInfo.ClassInfo ()
    this.CreateCtrlAddr = null
end sub

sub ClassInfo.~ClassInfo ()  
end sub

'**
'*
'*  Classes    
'*    (Published),   (Published)
'*
'*
class Classes: implements Collection
public:

     function GetClassFromName ( byval ClassName as string ) as pointer
         dim i as integer, c as integer
         dim ret as pointer = null
         c = this.count
         if c > 0 then
            for i = 0 to c-1
              dim byref ci as ClassInfo
              set ci = this.item (i)
              if lcase(ci.Name) = lcase(ClassName) then
                 ret = ref ci
                 'exit for
              end if
            next
         end if
         return = ret
     end function


     sub Classes ()
     sub ~Classes ()
end class

sub Classes.Classes ()
end sub

sub Classes.~Classes ()
end sub

class ConstInfo: implements Object

      dim Name as string
      dim Value as string

end class


class EnumInfo: implements Object

     dim Name as string
     dim Constants as Collection

     declare function GetConstNameFromValue ( byval Value as string ) as string

     sub EnumInfo ()

end class



function EnumInfo.GetConstNameFromValue ( byval Value as string ) as string
dim i as integer, c as integer
  c = this.Constants.Count
  for i = 0 to c - 1

      dim byref ci as ConstInfo
      set ci = this.Constants.Item (i)

      if ci.Value = Value then

         return = ci.Name

      end if

  next

end function

sub EnumInfo.EnumInfo ()
end sub

class Enums: implements Collection

     '   enum ,     EnumInfo
     declare function GetEnumByName ( byref Type as string ) as pointer
     '  ,     ConstInfo   EInfo  EnumInfo
     declare function GetConstByName ( byref ConstName as string, byref EInfo as pointer ) as pointer

     sub Enums ()
     sub ~Enums ()

end class


function Enums.GetConstByName ( byref ConstName as string, byref EInfo as pointer ) as pointer
dim i as integer, c as integer
 return = null
 c = this.Count 
 if c > 0 then

  for i = 0 to c - 1
 
   dim byref e as EnumInfo
   set e = this.Item (i)

     dim i2 as integer, c2 as integer
     c2 = e.Constants.Count
     if c2 > 0 then
        for i2 = 0 to c2 - 1

           dim byref ci as ConstInfo
           set ci = e.Constants.Item (i2)

           if lcase (ci.Name) = lcase (ConstName) then

              return = ref ci
              EInfo = ref e

           end if

        next
     end if
  next
 end if
end function

function Enums.GetEnumByName ( byref Type as string ) as pointer
dim i as integer, c as integer
 return = null
 c = this.Count 
 if c > 0 then

  for i = 0 to c - 1
 
   dim byref e as EnumInfo
   set e = this.Item (i)
   if lcase(e.Name) = lcase (Type) then
      return = ref e
   end if
  next
 end if
end function

sub Enums.Enums ()
end sub

sub Enums.~Enums ()
end sub

'global variables
dim Classes as Classes
dim Enums as Enums


''------------------------------
function ClassInfo.isImplement ( byval ClassName as string ) as boolean
dim ret as boolean = false
dim ex as boolean = false


      if lcase(this.Name) = lcase(ClassName) then ret = true
      if ret = false then

        dim byref cc as ClassInfo
        set cc = ref this
        do 

         if ref cc <> null then 
         if not (cc.ImplementClass = "") then
            if lcase(cc.ImplementClass) = lcase(ClassName) then 
               ret = true
            else
               set cc = classes.GetClassFromName (cc.ImplementClass)
            end if
         end if
         else
   
         ex = true  
         end if

         if ret = true then ex = true


         if ex = true then
               exit do
         end if

        loop

      end if
return = ret
end function


function ClassInfo.GetPropertyFromNameClass ( byval PropertyName as string, byval ClassName as string ) as pointer
       dim ret as pointer = null
       dim i as integer, c as integer
       dim byref ci as ClassInfo
       set ci = classes.GetClassFromName ( ClassName )
       if ref ci <> null then
       c = ci.propertys.count
       if c > 0 then
          for i = 0 to c-1
          dim byref pi as PropertyInfo
          set pi = ci.propertys.item (i)
          if pi.Name = PropertyName then
             ret = ref pi
          end if
          next
       end if
       end if

       if ref ci <> null then
       if ret = null then
       if not (ci.ImplementClass = "") then
          ret = ci.GetPropertyFromNameClass ( PropertyName, ci.ImplementClass )
       end if
       end if
       end if
       return = ret
end function

function ClassInfo.GetPropertyFromName ( byval PropertyName as string ) as pointer
    return = this.GetPropertyFromNameClass ( PropertyName, this.Name )
end function

'-----------
function PropertyInfo.GetValue ( byref Obj as Object ) as string
dim pd as string = DataType

          if (enums.GetEnumByName (pd)) <> null then pd = "integer"
          if lcase(pd) = "string" then
             dim a as string
             local_ad = GetPropAddr
             local_rc = ref Obj
             local_sc = ref a
             asm
                push eax
                push dd ptr local_rc
                push dd ptr local_sc
                call dd ptr local_ad
                add esp, 12
             end asm
             return = a
          end if
          if (lcase(pd) = "integer") or (lcase(pd) = "long") or (lcase(pd) = "color") then
             dim val as integer
             local_ad = GetPropAddr
             local_rc = ref Obj
             local_sc = ref val
             asm
                push eax
                push dd ptr local_rc
                push dd ptr local_sc
                call dd ptr local_ad
                add esp, 12
             end asm
             return = str(val)

          end if
          if lcase(pd) = "boolean" then
             dim b as boolean
             local_ad = GetPropAddr
             local_rc = ref Obj
             local_sc = ref b
             asm
                push eax
                push dd ptr local_rc
                push dd ptr local_sc
                call dd ptr local_ad
                add esp, 12
             end asm
             return = str(b)
          end if
end function


function PropertyInfo.SetValue ( byref Obj as Object, byval Value as string ) as string
dim pd as string = DataType
        if PutPropAddr <> 0 then
          if (enums.GetEnumByName (pd)) <> null then pd = "integer"
          if lcase(pd) = "string" then
             dim a as string 
             a = Value
             local_ad = PutPropAddr
             local_rc = ref Obj
             local_sc = ref a
             asm
                push eax
                push dd ptr local_rc
                push dd ptr local_sc
                call dd ptr local_ad
                add esp, 8
             end asm
          end if
          if (lcase(pd) = "integer") or (lcase(pd) = "long") or (lcase(pd) = "color") then
             dim va as integer 
             va = val(Value)
             local_ad = PutPropAddr
             local_rc = ref Obj
             local_sc = ref va
             asm
                push eax
                push dd ptr local_rc
                push dd ptr local_sc
                call dd ptr local_ad
                add esp, 8
             end asm
          end if
          if lcase(pd) = "boolean" then
             dim b as boolean 
             b = val(Value)
             local_ad = PutPropAddr
             local_rc = ref Obj
             local_sc = ref b
             asm
                push eax
                push dd ptr local_rc
                push dd ptr local_sc
                call dd ptr local_ad
                add esp, 8
             end asm
          end if
         end if
end function

sub ClassInfo.GetEventsInfo ( byval ClassName as string, byref EventCol as Collection )
       dim i as integer, c as integer
       dim byref ci as ClassInfo
       set ci = classes.GetClassFromName ( ClassName )

       if ref ci <> null then
       c = ci.events.count
       if c > 0 then
          for i = 0 to c-1
'msgbox ClassName

          dim byref pi as EventInfo
          set pi = ci.events.item (i)

          EventCol.Add ( pi )
          'if pi.Name = PropertyName then
          '   ret = ref pi
          'end if
          next
       end if
       end if

       if ref ci <> null then
       if not (ci.ImplementClass = "") then
          ci.GetEventsInfo ( ci.ImplementClass, EventCol )
       end if
       end if
end sub

sub ClassInfo.GetEventsInfo ( byref EventCol as Collection )
    this.GetEventsInfo ( this.ClassName, EventCol )
end sub


sub InitLibrary
end sub

sub ReleaseLibary
end sub


