'*
'* Vector.bas - Class of the System module 
'* 
'* Copyright(c) 2004-2006 by Metlashevskiy Egor. All right reserved  
'*
'*  Vector  -.
'*        ,  
'*    .
'*
unit lang.Collection
           
import lang.object
import windows.messagebox

public class Collection: implements Object

  private m_Memory as pointer       '    
  private m_Count as integer        ' - 
  private m_AllocSize as integer    '     
  private m_isAllocated as boolean  '    
  private m_BadStatus as integer    '  0 -                     
  private m_Delta as integer        '    


  public function isEmpty () as boolean
         return = (m_Memory = NULL)
  end function


  '**
  '* - 
  '*
  public function Count () as integer
      return = m_Count
  end function

  public sub _del_ptr()

    if m_isAllocated then
    
       mfree m_Memory
       m_isAllocated = false
       m_Count = 0
       m_AllocSize = 0
       m_Memory = NULL

    end if

  end sub
  
  '**
  '*    
  '*
  private sub Resize ( byval New_Size as integer )
  
     dim new_ptr as pointer
     dim nsize as integer
    
     nsize = New_Size + m_Delta
      
     if ( m_AllocSize < New_Size ) then
         
         
          new_ptr = malloc ( nsize + 1 )

          if m_Memory <> NULL then
          memcpy ( new_ptr, m_Memory, m_AllocSize )
          end if

          m_AllocSize = nsize
          if ( m_Memory <> NULL ) then
            mfree ( m_Memory )
          end if
          m_Memory = new_ptr
          m_isAllocated = true
     
     end if

  end sub
    
  '**
  '*   
  '*
  public function Item ( byval Index as integer ) as pointer
  
    if (Index >= 0) and (Index < m_Count ) then 

    dim byref Val as pointer
    set Val = m_Memory + (Index * 4)
    return = Val
  
    end if

  end function
  
  '**
  '* 
  '*
  public sub Clear ()
    m_Count = 0
  end sub

  '**
  '*   ,     ,   -1
  '*
  function IndexOf ( byval Item as pointer ) as integer
     return = -1
     dim i as integer, c as integer
     c = this.Count
     if c > 0 then
        for i = 0 to c - 1
            if this.Item(i) = Item then

               return = i
               exit for
            end if
        next
     end if

  end function

  function IndexOf ( byref Obj as Object ) as integer
      return = this.IndexOf ( ref Obj )
  end function

  public sub Delete ( byval Index as integer )

    if (Index >= 0) and (Index < m_Count ) then 

       dim t as dword
       dim start as dword
       dim cnt as dword

       t = (Index * 4)
       start = t + 4
       cnt = (m_Count * 4) - start

       if (cnt > 0)  then

          memcpy (m_Memory + t, m_Memory + start, cnt)

       end if

       if m_Count > 0 then
          m_Count = m_Count - 1
       end if

    end if

  end sub



  '**
  '*  
  '*
  public sub Add ( byval Ptr as pointer )
  
    dim ncount as integer
    dim nsize as integer
    
    ncount = m_Count + 1
    nsize = ncount * 4

    if ( m_AllocSize < nsize ) then
         this.ReSize ( nsize )
    end if
    
    if (m_BadStatus = 0) then
    
      dim byref Val as pointer
      set Val = m_Memory + ( nsize - 4 )
      Val = Ptr
      m_Count = ncount
    
    end if
    
  end sub

  
  public sub Add ( byref Obj as Object )

     this.Add ( ref Obj )

  end sub


  public virtual operator := ( byref col as Collection ) as byte

     this._del_ptr()

     if col.m_isAllocated = true then

       this.Resize ( col.m_AllocSize )
       memcpy ( this.m_Memory, col.m_Memory, col.m_AllocSize )
       this.m_Count = col.m_Count
       this.m_Delta = col.m_Delta

     end if

  end function
 
  '**           
  '* 
  '*
  sub Finalize ()
    this._del_ptr()
  end sub

  '**
  '* 
  '*
  public declare sub Collection ()
  public declare sub Collection ( byval Delta as integer )  

        
end class

public sub Collection.Collection ()
    m_isAllocated = false
    m_AllocSize = 0
    m_Count = 0
    m_Memory = 0
    m_Delta = 64
    m_BadStatus = 0
end sub

public sub Collection.Collection ( byval Delta as integer )
    this.Collection()
    m_Delta = Delta
end sub


sub InitLibrary
end sub
sub ReleaseLibrary
end sub





                 