'**
'*
'*      , ,  
'*
'*
unit Lang.Files

import lang.StringBuffer

$document "../../doc/Files.htm"

Const MAX_PATH = 260
Const MAXDWORD = &HFFFF
Const INVALID_HANDLE_VALUE = -1
Const FILE_ATTRIBUTE_ARCHIVE = &H20
Const FILE_ATTRIBUTE_DIRECTORY = &H10
Const FILE_ATTRIBUTE_HIDDEN = &H2
Const FILE_ATTRIBUTE_NORMAL = &H80
Const FILE_ATTRIBUTE_READONLY = &H1
Const FILE_ATTRIBUTE_SYSTEM = &H4
Const FILE_ATTRIBUTE_TEMPORARY = &H100

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName(MAX_PATH) As Byte 
    cAlternate(15) As Byte 
End Type

Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByRef lpFileName As String, byref lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, byref lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByRef lpFileName As String) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Declare Function DeleteFile Lib "kernel32" Alias "DeleteFileA" (byref lpFileName As String) As Long

'**
'*   
'*
function ExtractFileExt ( filename as string ) as string
dim i as integer
    i = instr (len(filename), filename, ".", 1, false)
    if i <> -1 then
       return = mid (filename, i+1)
    end if
end function

'**
'*   
'*
function ExtractFileDrive ( filename as string ) as string

    if mid$(filename, 1, 1) = ":" then

       return = mid$(filename, 0,1)

    end if

end function

'**
'*   
'*
function ExtractFileName ( filename as string ) as string
dim i as integer, i2 as integer
    i = instr (len(filename), filename, "\", 1, false)
    i2 = instr (len(filename), filename, "/", 1, false) 
    if i2 > i then i = i2
    if i <> -1 then
       return = mid (filename, i+1)
    else
       return = filename
    end if
end function

'**
'*    
'*
function ExtractFilePath ( filename as string ) as string

 dim fn as string = ExtractFileName ( filename )
 if len(filename) > len(fn) then
 return = mid$( filename, 0, Len(filename) - Len(fn))
 end if

end function

'**
'*     
'*
function ExtractFileNameOnly  ( filename as string ) as string
dim fx as string = ExtractFileName ( filename )
dim ex as string = ExtractFileExt ( filename )
    return = mid (fx, 0, len(fx) - len(ex)-1)
end function

'**
'*       Path   Search, FindFiles = true  , false -  , RetAll = true -     
'*
function Files ( byval Path as string, byval Search as string, byval FindFiles as boolean, byval RetAll as boolean ) as StringBuffer

  dim hSearch as long
  dim WFD as WIN32_FIND_DATA
  dim Cont as integer = true
  dim rPath as string
  dim bSlash as string


  rPath = Path
  bSlash = mid$(rPath, len(rPath)-1,1)

  if (bSlash <> "\") and (bSlash <> "/") then
      rPath = rPath + "\"
  end if


  hSearch = FindFirstFile (rPath + Search, WFD)

    do
      dn$ = CharToStr ( ref WFD.cFileName )
      add = 0
      dim at as long
      at = GetFileAttributes( rPath + dn$ )

      if retall = false then
      if FindFiles = true then
         if at and FILE_ATTRIBUTE_DIRECTORY then
         else
           add = 1
         end if
      else
         if at and FILE_ATTRIBUTE_DIRECTORY then add = 1
      end if
      else
          add = 1
      end if


      if ( add ) Then
        return.Add ( dn$ )
      end if

        Cont = FindNextFile(hSearch, WFD)
        if Cont = false then exit do
    loop


  FindClose ( hSearch )

end function

'**
'*        Search
'*
function Files ( byval Path as string, byval Search as string) as StringBuffer
    return = files ( Path, Search, true, false)
end function

'**
'*        Search
'*
function Dirs ( byval Path as string, byval Search as string) as StringBuffer
    return = files ( Path, Search, false, false )
end function

'**
'*         Search
'*
function FilesAndDirs ( byval Path as string, byval Search as string) as StringBuffer
    return = files ( Path, Search, false, true )
end function


'**
'*        Path 
'*
function Files ( byval Path as string ) as StringBuffer
    return = FilesAndDirs ( Path, "*")
end function

function File ( byval FileName as string ) as StringBuffer

  dim hFile as FILE
  hFile = fopen ( FileName, "r+" )

  if ( hFile <> null ) then

     do
       dim s as string
       s = fgets ( hFile, 25600 )
       return.add ( s$ )
       if feof ( hFile ) then exit do
     loop

  fclose (hFile)
  end if


end function

