unit System
$option /nsys
'*                                                                              
'*  SYSTEM.BAS - Force Basic System Module                                      
'*                                                                              
'*  Copyright(c) 2004-2006 by Metlashevskiy Egor. All right reserved                 
'*                                                                              
'*
'*         Force Basic'.
'*       , , .
'*         
'*   ForceBasic,       
'*  /nsys.
'*   - .   
'*  ,     ,   
'*      () , ,
'* .
'*

$ifndef __SYSTEM_BAS
$define __SYSTEM_BAS

$include "system.hlp"
'*
'*  
'*        
typedef Integer as long
typedef Boolean as byte
typedef Pointer as dword
typedef Any as dword
            
'*
'* 
'*
const TRUE as Byte = 1
const FALSE as Byte = 0
const NOTHING as byte = 0
const NULL as integer = 0

'   

public enum ArgumentTypes
  TPSMALL    = 0
  TPBYTE     = 1
  TPSHORT    = 2
  TPWORD     = 3
  TPDWORD    = 4
  TPLONG     = 5
  TPINTEGER  = 5
  TPSINGLE   = 6
  TPDOUBLE   = 7
  TPEXTENDET = 8
  TPSTRING   = 9
  TPUNKNOWN  = 255
end enum
                
$include "arguments.bas"
$include "strings.bas"
$include "math.bas"
$include "filesystem.bas"
$include "resource.bas"

'*
'*                                             
'*
sub Exit (byval Status as long)
  asm mov eax, dd ptr ebp+8     ;EAX = Status
  asm exit                      ;Terminate process
end sub

sub Exit ()
  asm mov eax, 0   
  asm exit                      
end sub


'*
'*     _Size .
'*       
'*      . 
'* 
function mAlloc (byval Size as dword) as pointer
asm
     new eax, dd ptr ebp+8      ;  
     mov esi, dd ptr ebp+12
     mov dd ptr esi, eax
end asm
end function      

'*
'*     malloc
'*
sub mFree (byval Ptr as pointer)
asm
     del dd ptr ebp+8           ;Free memory
end asm
end sub

'*
'*   (   )
'*
sub DeleteClass (byval ClassPtr as pointer)
  asm sys 63
end sub

'*
'* Shell  (  )
'*
sub Shell (byval Command as string)
  asm sys 84
end sub

'*
'*   
'*
function ParamCount () as integer
  asm sys 21
end function

function ParamStr ( byval Index as integer ) as string
  asm sys 22
end function

'*
'*  BASIC- COMMAND$
'* (     )
'*
function Command$
  asm sys 23
end function

function Environ$ ( byval Name as string )
  asm sys 24
end function

function GetCallBackEventPtr () as long
  asm sys 25
end function

'*
'* AddressOf -   
'*
function AddressOf ( byval vPointer as pointer ) as pointer
asm
   push eax
   push ebx
   lpa eax, dd ptr ebp+8

   mov ebx, dd ptr ebp+12
   mov dd ptr ebx, eax

   pop ebx
   pop eax
end asm
end function

'*
'* VirtualOf -     
'*
function VirtualOf ( byval rPointer as pointer ) as pointer
  asm sys 38
end function

sub DoEvents 
  asm sys 66
end sub

sub LoopEvents
    do: doevents: loop 
end sub

sub ReturnEAX ( byval Value as dword ) 
  asm sys 103
end sub

function _vm_info ( byval param as integer ) as integer
  asm sys 104
end function


$include "runable.bas"


sub InitLibrary
end sub

sub ReleaseLibrary
end sub
$endif