'*
'*
'* Force Basic Runable Module                                               
'*
'* Copyright(c) 2005 by Metlashevskiy Egor. All right reserved                 
'*
'*     
'*
'*
$DEFINE ID_EVENT_ONERROR 0
'$DEFINE BUILD_RU


'
'some function for system manipulation between events
' 
private sub set_sys_event ( byval id as integer, byval proc as pointer ): asm sys 100: end sub
private function get_sys_event ( byval id as integer ) as pointer: asm sys 101: end function
private function get_err_code () as dword: asm sys 102: end function


class Runable

      public property OnError as pointer

      public function ErrCode() as dword
             return = get_err_code()
      end function

      public function ErrDesc as string
          dim err as dword = this.ErrCode()
          $IFDEF BUILD_RU
              if err = 1 then return = "     "
              if err = 1000 then return = " "
              if err = 1001 then return = "   "

          $ELSE
              if err = 1 then return = "Access validation"
              if err = 1000 then return = "Stack overflow"
              if err = 1001 then return = "Declare(s) no correct"
          $ENDIF
      end function

      public function Version () as integer
             return = _vm_info (0)
      end function

      public function ByteCodeSize () as integer
             return = _vm_info (1)
      end function

      public function Title () as string
             dim str_ptr as pointer
             str_ptr = _vm_info(2)
             return = CharToStr(VirtualOf(str_ptr))
      end function

      public function DLL_Count () as integer
             return = _vm_info(3)
      end function

      public function DLL_Proc_Count () as integer
             return = _vm_info(4)
      end function

      public function StackSize () as integer
             return = _vm_info(5)
      end function

      public function StackSpace () as integer
             return = _vm_info(6)
      end function


end class

sub Runable.OnError ( byref Unhandler as pointer )
    set_sys_event ( ID_EVENT_ONERROR, Unhandler )
end sub

function Runable.OnError () as pointer
    return = get_sys_event (ID_EVENT_ONERROR)
end function



public Runable as Runable

