'*
'* Brush Class
'*
'* Copyright(c) by Metlashevskiy Egor <br>
'*
'*  '' 
'*
unit windows.gui.Brush

$document "../../../doc/Brush.htm"

import windows.gui.Control

published class Brush: implements Control
private:
      dim m_brush as pointer = null

public:
      dim LogBrush as LOGBRUSH

      '   Brush (WIN API)
      property hBrush as long

published:

      ' 
      property Style as long
      ' 
      property Hatch as long
      ' 
      property Color as Color
public:

      '      
      event OnChange ()

      ' ,        
      declare sub Refresh ()
      '    
      declare sub CreateSolidBrush ( byval Brush as long )

      '
      sub Brush ( byref Parent as Control )
end class

'default events
private sub Brush_OnChange ( byref Brush as Brush ): end sub

sub Brush.CreateSolidBrush ( byval Brush as long )
  if m_brush <> null then
     DeleteObject ( m_brush )
  end if
  this.m_brush = CreateSolidBrush (Brush)
  this.LogBrush.lbColor = Brush  
end sub

sub Brush.Color ( byref m_Color as Color )
   this.LogBrush.lbColor = m_Color
   this.Refresh()
   this.OnChange()
end sub

function Brush.Color () as Color
   return = this.LogBrush.lbColor
end function

sub Brush.Style ( byref m_Style as long )
   this.LogBrush.lbStyle = m_Style
   this.Refresh()
   this.OnChange()
end sub

function Brush.Style () as long
   return = this.LogBrush.lbStyle
end function

sub Brush.Hatch ( byref m_Hatch as long )
   this.LogBrush.lbHatch = m_Hatch
   this.Refresh()
   this.OnChange()
end sub

function Brush.Hatch () as long
   return = this.LogBrush.lbHatch
end function


sub Brush.hBrush ( byref m_hBrush as long )
   this.m_brush = m_hBrush
end sub

function Brush.hBrush () as long
  return = this.m_brush
end function

sub Brush.Refresh ()
  if m_brush <> null then
     DeleteObject ( m_brush )
  end if
  this.m_brush = CreateBrushIndirect (this.LogBrush)
end sub

sub Brush.Brush ( byref Parent as Control )

  this.ParentControl = Parent

  with this.logbrush
    .lbColor = 0
    .lbStyle = BS_SOLID 
    .lbHatch = HS_VERTICAL 
  end with

    'this.lbColor = 123123123
    'this.lbStyle = BS_SOLID
    'this.lbHatch = HS_VERTICAL
  this.OnChange = subptr ( Brush_OnChange )

end sub


sub InitLibrary

    RegisterClass ( "Brush", subptrclass ( Brush, Brush ))

end sub
