'*
'* Canvas Class
'*
'* Copyright(c) by Metlashevskiy Egor <br>
'*
'*  -    , , ,  , ...
'*     Font, Brush, Pen
'*
unit windows.gui.Canvas

$document "../../../doc/Canvas.htm"

import windows.gui.Control
import windows.gui.Font
import windows.gui.Brush
import windows.gui.Pen
import lang.AnsiString

published class Canvas: implements Control
private:
       dim m_dc as long = 0
public:
      dim Font as Font ( this )  '   Canvas
      dim Brush as Brush ( this ) 
      dim Pen as Pen ( this )

      '   DC
      property hDC as long

published:
      '  
      property BackStyle as BackgroundStyles
      ' 
      property TextColor as Color
public:


      ' 
      declare sub Rectangle ( byval X1 as integer, byval Y1 as integer, byval X2 as integer, byval Y2 as integer )
      ' 
      declare sub TextOut ( byval X as integer, byval Y as integer, byval Text as string )
      ' 
      declare sub Line ( byval X1 as integer, byval Y1 as integer, byval X2 as integer, byval Y2 as integer)



      'declare sub SetBkColor

      ' ,          
      declare sub Refresh ()

      sub Canvas ( byref Parent as Control )

end class

sub Canvas.BackStyle ( byref Style as BackgroundStyles )
    SetBkMode ( this.hDC, Style )
end sub

function Canvas.BackStyle () as BackgroundStyles
    return = GetBkMode ( this.hDc )
end function

sub Canvas.TextColor ( byref Color as Color )
    SetTextColor ( this.hDC, Color )
end sub

function Canvas.TextColor () as Color
    return = GetTextColor ( this.hDc )
end function

private sub Canvas_Font_OnChange ( byref Font as Font )
if Font.GetParentClass <> null then
 dim byref Can as Canvas
 set Can = Font.GetParentClass
    Can.Refresh()
end if
end sub

private sub Canvas_Brush_OnChange ( byref Brush as Brush )
if Brush.GetParentClass <> null then
 dim byref Can as Canvas
 set Can = Brush.GetParentClass
 Can.Refresh()
end if
end sub

private sub Canvas_Pen_OnChange ( byref Pen as Pen )
if Pen.GetParentClass <> null then
 dim byref Can as Canvas
 set Can = Pen.GetParentClass
 Can.Refresh()
end if
end sub

sub Canvas.Refresh ()
if m_dc <> null then
   dim lf as long 
   lf = SelectObject (m_dc, this.Font.hFont)
   'DeleteObject (lf)
   lf = SelectObject (m_dc, this.Brush.hBrush)
   'DeleteObject (lf)
   lf = SelectObject (m_dc, this.Pen.hPen)
   'DeleteObject (lf)
   'print "REFRES|H\n", this.Brush.hBrush
end if
end sub

sub Canvas.hDC ( byref m_DC as long )
    if this.m_dc <> null then
       DeleteDC ( this.m_dc)
    end if
    this.m_dc = m_DC
    'SetTextAlign (this.hdc, TA_RIGHT)
    this.Refresh()
end sub

function Canvas.hDC () as long
    return = this.m_dc
end function

sub Canvas.Rectangle ( byval X1 as integer, byval Y1 as integer, byval X2 as integer, byval Y2 as integer )
    Rectangle ( this.m_dc, x1, y1, x2, y2)
end sub

sub Canvas.Line ( byval X1 as integer, byval Y1 as integer, byval X2 as integer, byval Y2 as integer)
    dim op as pointapi
    MoveToEx ( this.m_dc, X1,Y1, op)
    LineTo ( this.m_dc, X2,Y2)
end sub

sub Canvas.TextOut ( byval X as integer, byval Y as integer, byval Text as string )
dim a as AnsiString
a = Text
    TextOut ( this.m_dc, X, Y, AddressOf(a.Data), a.Length())
end sub

sub Canvas.Canvas ( byref Parent as Control )
    this.ParentControl = Parent
    this.Font.OnChange = subptr ( Canvas_Font_OnChange )
    this.Brush.OnChange = subptr ( Canvas_Brush_OnChange )
    this.Pen.OnChange = subptr ( Canvas_Pen_OnChange )
    this.Font.Name = "Font"
    this.Brush.Name = "Brush"
    this.Pen.Name = "Pen"
    this.Font.ChildClass = true
    this.Brush.ChildClass = true
    this.Pen.ChildClass = true


end sub


sub InitLibrary

    RegisterClass ( "Canvas", subptrclass ( Canvas, Canvas ) )

end sub
