'*
'* Control Class
'*
'* Copyright(c) by Metlashevskiy Egor <br>
'*
'*   ,     GUI  Control
'*

unit windows.gui.Control

$document "../../../doc/Control.htm"

import lang.Object
import windows.MessageBox
import lang.Classes
import lang.AnsiString
import windows.gui.Widget

public LoaderStatus as integer = 0

public class LoaderStoreProperty
       dim ptr as pointer
       dim pn as string
       sub LoaderStoreProperty
       sub ~LoaderStoreProperty

end class

sub LoaderStoreProperty.LoaderStoreProperty
end sub

sub LoaderStoreProperty.~LoaderStoreProperty
end sub


public Loader_Components as Collection ()
public Loader_Components_Props as Collection ()


public control_countid as integer = 0
private control_ident as integer = 4
private control_inh as integer = 0

$include "Gui.inc"

'**
'*  ControlEventBuilder  FormBuilder 
'*  ,       .
'*
class ControlEventBuilder: implements Object
      virtual sub GetEventDeclares ( byref ret as string, byref ctrl as Object, byval cmd as integer ): end sub
      virtual sub StoreCurrentProperty ( byref ret as boolean, byref ctrl as Object, byref pi as PropertyInfo ): end sub
end class

'**
'*
'*  Control    . .  
'*           .
'*        .   
'*     GetControlCount, GetControl
'*
'*
published class Control: implements Object
private:
      dim m_parent as long = 0
      dim m_name as string
      dim m_Controls as Collection
      dim m_ctlid as integer = 0
      dim m_designing as boolean = false
      dim m_childclass as boolean = false
      
public:


public:

      '  
      property ParentControl as Control

      ' True,      
      property IsDesigning as Boolean

      ' L 
      published property Name as string

      ' L 
      property ControlId as integer

      ' true,   v  (     𬪸  )
      ' =  v  Form.Canvas.ChildClass = true
      property ChildClass as boolean

      '**
      '* T  ,     null
      '*
      function GetParentClass () as pointer
          return = m_parent
      end function


      '**
      '* -     .
      '*
      sub AddControl ( byref m_Control as Control )
          this.m_controls.add ( ref m_Control )
      end sub

      '**
      '* L    Control  
      '*
      function GetControl ( byval Index as integer ) as pointer
               return = this.m_controls.item ( Index )
      end function	

      '**
      '* T -   (  )
      '*
      function GetControlCount () as integer
          return = this.m_controls.count
      end function

      '**
      '* T v  Control   
      '*
      function GetControlById ( byval Id as integer ) as pointer
      dim i as integer, c as integer
      dim ret as pointer = 0

         c = this.GetControlCount
         if c > 0 then
            for i = 0 to c-1
               dim byref mi as Control
               set mi = this.GetControl ( i )
               if mi.ControlId = Id then
                  ret = ( set mi )
               else
                  dim fv as pointer
                  fv = mi.GetControlById ( Id )
                  if fv <> 0 then ret = fv
               end if
            next

         end if
         return = ret

      end function

      ' T true,   v    CName
      function IsImplement ( byval CName as string ) as boolean
          return = false
          dim byref ci as ClassInfo
          set ci = classes.GetClassFromName (this.ClassName)
          if ref ci <> null then
             return = ci.IsImplement ( CName )
             'msgbox ci.Name + " | " + CName + " | "+ str(return)
          end if
      end function

      '**
      '* T v  Control  hWnd
      '*
      function GetControlByhWnd ( byval Wnd as integer ) as pointer
      dim i as integer, c as integer
      dim ret as pointer = 0

         c = this.GetControlCount
         if c > 0 then
            for i = 0 to c-1
               dim byref mi as Widget
               set mi = this.GetControl ( i )
               if mi.IsImplement ("Widget") then
               if mi.hWnd = Wnd then
                  ret = ( set mi )
               else
                  dim fv as pointer
                  fv = mi.GetControlById ( Wnd )
                  if fv <> 0 then ret = fv
               end if
               end if
            next

         end if
         return = ret

      end function

      '**
      '* T v  Control   
      '*
      function GetControlByName ( byval cName as string ) as pointer
      dim i as integer, c as integer
      dim ret as pointer = 0

         c = this.GetControlCount
         if c > 0 then
            for i = 0 to c-1
               dim byref mi as Control
               set mi = this.GetControl ( i )
               if mi.Name = cName then
                  ret = ( ref mi )
               else
                  dim fv as pointer
                  fv = mi.GetControlByName ( cName )
                  if fv <> 0 then ret = fv
               end if
            next

         end if
         return = ret

      end function


      function GetParentForm () as pointer
         return = NULL
         dim byref c as Control
         dim byref pc as Control
         set pc = ref this
         do
            set c = pc.GetParentClass()
            if ref c <> NULL then
               if c.IsImplement ("CustomForm") then 
                  return = ref c
                  exit do
               end if
            else
               exit do
            end if

            set pc = ref c

         loop
      end function

'      sub ControlsSendMessage (ByVal ClassName as string, ByVal wMsg As Long, ByVal wParam As Long, byval lParam As Long)
'     dim i as integer, c as integer
'         c = this.GetControlCount
'         if c > 0 then
'            for i = 0 to c-1
'               dim byref mi as Control
'               set mi = this.GetControl ( i )
'             
'               if (set mi) <> null then
'               if mi.ClassName = ClassName then
'                  dim byref wi as Widget
'                  'set wi = ref mi
'                  'SendMessage wi.hWnd, wMsg, wParam, lParam
'               end if
'               end if
'            next
'         end if
'      end sub


      public virtual operator := ( byref col as Collection ) as byte
      end function

      '**
      '* T   .
      '* +  Eidt,   Edit.Caption, ..
      '*       
      '*
      virtual function Value () as string
      end function

      virtual sub SetupValue ( byval m_Value as string )
      end sub

      '*
      '* T     ,   CName
      '*
      function GetPropertiesDataClass ( byref CName as string, byref Builder as ControlEventBuilder) as string
         dim byref ci as ClassInfo
         dim ret as string
         set ci = classes.GetClassFromName ( CName )
         if ref ci <> null then
            dim i as integer, c as integer
            c = ci.propertys.count
            if c > 0 then
            for i = 0 to c-1
                dim byref pi as PropertyInfo
                set pi = ci.propertys.item (i)


                dim rr as boolean = true
                Builder.StoreCurrentProperty (rr, this, pi)

                if rr = true then
                   ret = ret + space(control_ident * control_inh) + pi.Name + " = " + pi.GetValue ( this ) + " \n"
                end if
            next
            end if

            if not (ci.ImplementClass = "")  then
               ret = ret + this.GetPropertiesDataClass ( ci.ImplementClass, Builder )
            end if
         end if
         return = ret
      end function

      '*
      '* T     
      '*
      function GetPropertiesData ( byref Builder as ControlEventBuilder ) as string
          return = this.GetPropertiesDataClass (this.ClassName, Builder )
      end function

      function StoreControlData ( byref Builder as ControlEventBuilder ) as string
          dim ret as string
          dim i as integer, c as integer

          'if (control_inh > 0 ) then
          '   control_inh = control_inh - 1
          'end if

          ret= ""
          'ret = ret + "\n"

          ret = ret + space (control_inh * control_ident) + "CREATE " + this.Name + " AS " + this.ClassName + "\n"
          control_inh = control_inh + 1
          ret = ret + this.GetPropertiesData (Builder)
       
          c = this.GetControlCount 
          if c > 0 then
             for i = 0 to c -1
                 dim byref ct as Control
                 set ct = this.GetControl (i)
                 control_inh = control_inh + 1
                 ret = ret + ct.StoreControlData ( Builder )
                 control_inh = control_inh - 1
             next
          end if
          control_inh = control_inh - 1
          ret = ret +space (control_inh * control_ident)  +  "END CREATE \n"
          return = ret
      end function


      private function _Build_Fields (byval s as string, byref ret as string, byref ctrl as Control, byref Builder as ControlEventBuilder) as integer

         dim i as integer, c as integer
         c = ctrl.GetControlCount()
         if c > 0 then

            for i = 0 to c - 1

                dim byref com as Control
                set com = ctrl.GetControl (i)

                if ref com <> null then
                if com.ChildClass = false then

                   dim is as string
                   is = "this." + com.Name
                   ret = ret + "  dim " + com.Name + " as " + com.ClassName + " ( "+mid(s,0,len(s)-1)+" ) \n"
                   'ret = ret + " dim " + com.Name + " as " + com.ClassName + " ( "+ is +" ) \n"
                   this._Build_Fields ( "this." + com.Name + ".",ret , com, Builder)

                end if
                end if


            next


         end if

      end function


      private function _Build_CI (byref ret as string, byref ctrl as control, byref ci as ClassInfo, byval s as string, byref Builder as ControlEventBuilder) as integer

         dim i as integer, c as integer
         dim go as boolean = false
         c = ci.propertys.count
'print ci.name,c , "\n"



         if c > 0 then

            for i = 0 to c-1

                dim byref pi as PropertyInfo()
                set pi = ci.propertys.item (i)


                if ref pi <> null then
                   dim ps as string = pi.GetValue (ctrl)
                   dim kv as string

                   kv = ""
                   if lcase(pi.DataType) = lcase("string") then kv = "\'"
                   'ret = ret + "      " + s + pi.Name + " = " + kv + ps + kv+"\n"
                   dim rr as boolean = true
                   Builder.StoreCurrentProperty (rr, ctrl, pi)
                   if rr = true then

                       if go = false then
                       ret = ret + "       with " + mid(s,0,len(s)-1)+ "\n"
                       end if

                       if (mid(s,0,len(s)-1) = "this") and (pi.Name = "Visible") then
                       else
                       ret = ret + "            ." + pi.Name + " = " + kv + ps + kv+"\n"
                       end if
                       go = true

                   else

                      'msgbox 

                   end if
                end if

            next

         if go = true then
         ret = ret + "       end with\n"
         end if

         end if

         if not (ci.ImplementClass = "") then
            dim byref nci as ClassInfo
            set nci = classes.GetClassFromName (ci.ImplementClass)
            if ref nci <> null then
            this._Build_CI ( ret, ctrl, nci, s, Builder)
            end if
         end if



      end function

      private function _Build_Com_Props ( byref ret as string, byref ctrl as Control, byval s as string, byref Builder as ControlEventBuilder) as integer

           dim byref ci as ClassInfo
           set ci = classes.GetClassFromName (ctrl.ClassName)
           'msgbox ci.Name

           if ref ci <> null then

              this._Build_CI ( ret, ctrl, ci, s, Builder)
           end if

      end function

      private function _Build_Fields_Props (byref ret as string, byref ctrl as Control, byval s as string, byref Builder as ControlEventBuilder) as integer
         dim i as integer, c as integer
         c = ctrl.GetControlCount()
         if c > 0 then

            for i = 0 to c - 1

                dim byref com as Control
                set com = ctrl.GetControl (i)

                if ref com <> null then
                'if com.ChildClass = false then
                   'ret = ret + " dim " + com.Name + " as " + com.ClassName + " ( this ) \n"
                 dim fg1 as string = s + "." + com.Name + "."
                 dim fg2 as string = s + "." + com.Name

                 if com.ChildClass = false then
                   fg1 = "this." + com.Name + "."
                   fg2 = "this." + com.Name
                 end if 

                   this._Build_Com_props ( ret, com, fg1, Builder )
                   this._Build_Fields_Props ( ret , com, fg2, Builder)

                'end if
                end if
            next
         end if
      end function

      function TemplateClassCode ( byref Builder as ControlEventBuilder ) as string

          dim ret as string
          ret = ret + "'**\n"
          ret = ret + "'* Warning! generated by FormBuilder\n"
          ret = ret + "'*\n\n"

          ret = ret + "'\n"
          ret = ret + "' Use Windows GUI Library\n"
          ret = ret + "'\n"
          ret = ret + "import windows.gui.* \n\n"

          Builder.GetEventDeclares (ret, this, 0)


          ret = ret + "'\n"
          ret = ret + "' Designed Class "+this.Name+"\n"
          ret = ret + "'\n"
          ret = ret + "published class " + this.Name + ": implements " + this.ClassName + "\n"

          dim i as integer, c as integer
          ret = ret + "  '\n"
          ret = ret + "  ' Incapsuling objects\n"
          ret = ret + "  '\n"
          this._Build_Fields ( "this.", ret, this, Builder)


          ret = ret + "  '\n"
          ret = ret + "  ' NOTE: Initialize Components, Propertys, Events, Objects\n"
          ret = ret + "  ' This method called then the class is created.\n"
          ret = ret + "  ' Property Visible not write in this section, so then the class has been\n"
          ret = ret + "  ' created you need set visible property or call method as Form.Show().\n"
          ret = ret + "  '\n"
          ret = ret + "  sub Initialize () \n"
          this._Build_Com_props ( ret, this, "this.", Builder)
          this._Build_Fields_Props ( ret, this, "this", Builder)
          Builder.GetEventDeclares (ret, this, 1)
          ret = ret + "  end sub \n\n"
          Builder.GetEventDeclares (ret, this, 3)

          ret = ret + "  sub " + this.Name + " () \n"
          ret = ret + "end class \n\n"

          ret = ret + "sub " + this.Name + "." + this.Name + " () \n"
          ret = ret + "  this.Initialize()\n"
          ret = ret + "end sub \n"
          Builder.GetEventDeclares (ret, this, 2)



          return = ret

      end function


      '*
      '* T  , : <br>
      '* dim Form1 as Form <br>
      '* msgbox Form1.GetProp ("Caption")
      '*
      function GetProp ( byval PropertyName as string ) as string
         dim byref ci as ClassInfo
         dim ret as string
         set ci = classes.GetClassFromName ( this.ClassName )
         if ref ci <> null then
            dim byref pi as PropertyInfo
            set pi = ci.GetPropertyFromName (PropertyName)
            if (ref pi) <> null then
               return = pi.GetValue ( this )
            end if
         end if
      end function
      '*
      '* L  , : <br>
      '* dim Form1 as Form <br>
      '* msgbox Form1.GetProp ("Caption")
      '*
      function SetProp ( byval PropertyName as string, byval Value as string ) as string
         dim byref ci as ClassInfo
         dim ret as string
         set ci = classes.GetClassFromName ( this.ClassName )
         if ref ci <> null then
            dim byref pi as PropertyInfo
            set pi = ci.GetPropertyFromName (PropertyName)
            if (ref pi) <> null then
               return = pi.SetValue ( this, Value )
            end if
         end if
      end function

      '  ,    (   )
      sub RegisterClass ( byval CreateMethod as pointer )

          dim byref ci as ClassInfo
          set ci = classes.GetClassFromName ( this.ClassName )
          if ref ci <> null then
             ci.CreateCtrlAddr = CreateMethod

          end if
      end sub



      declare sub RemoveControl ( byref Control as Control )

      virtual sub Free () : end sub

      sub Control ()
      sub ~Control ()

end class

'sub Control.ControlId ( byref id as integer ) 
'    this.m_ctlid = id
'end sub

sub Control.~Control ()

'msgbox "C~"
    if this.m_parent <> null then
       dim byref Par as Control
       set par = this.m_parent
       par.RemoveControl ( this )
    end if  
    dim i as integer, c as integer
    c = this.GetControlCount
    if c > 0 then
       for i = 0 to c-1
           dim byref ct as Control
           set ct = this.GetControl (0)
           if ct.ChildClass = false then
              delete ct
           end if
       next
    end if

    this.Free ()

end sub

sub Control.RemoveControl ( byref Control as Control )

dim i as integer, c as integer
dim delted as boolean = false


    c = this.GetControlCount ()
    if c > 0 then

       for i = 0 to c-1

        if delted = false then
           dim byref ctrl as Control
           set ctrl = this.GetControl (i)
           if (ref ctrl) = (ref Control) then
              this.m_Controls.Delete (i)
              delted = true
              'exit for
           end if

        end if

       next


    end if

end sub


function Control.ControlId () as integer
    return = this.m_ctlid
end function

sub Control.ControlId ( byref Id as integer )
    this.m_ctlid = Id
end sub

function Control.IsDesigning () as boolean
    return = this.m_designing
end function

sub Control.IsDesigning ( byref Designing as boolean )
    this.m_designing = Designing
end sub

function Control.ChildClass () as boolean
    return = this.m_childclass
end function

sub Control.ChildClass ( byref IsChild as boolean )
    this.m_childclass = IsChild
end sub

sub Control.ParentControl ( byref m_Control as Control )
    if this.m_parent <> null then
       dim byref mp as Control
       set mp = this.m_parent
       mp.RemoveControl ( this )
    end if

    this.m_parent = ref m_Control
    m_Control.AddControl ( this )


end sub

function Control.ParentControl () as Control
dim byref pc as Control
if this.m_parent <> null then
   set pc = m_parent
   return.m_parent = pc.m_parent
else
   return.m_parent = 0
end if
end function

sub Control.Name ( byref String as string )
    this.m_name = String
end sub

function Control.Name () as string
    return = this.m_name
end function

sub Control.Control ()
    this.Name = "Control" + str (control_countid)

    this.m_ctlid = control_countid
    control_countid = control_countid + 1
end sub


'**
'* L   ClassName, CreateMethod -     
'*
public sub RegisterClass ( byval ClassName as string, byval CreateMethod as pointer )
 dim byref ci as ClassInfo
 set ci = classes.GetClassFromName ( ClassName )
 if ref ci <> null then
    ci.CreateCtrlAddr = CreateMethod
 end if
end sub


private loc_a1 as dword
private loc_a2 as dword
private loc_a3 as dword

'**
'*
'* L     ClassName   Parent,
'*   TlassName   RegisterClass
'*
public function CreateControl ( byval ClassName as string, byref Parent as Control ) as pointer
dim ret as pointer = null
dim mem as pointer

 dim byref ci as ClassInfo
 set ci = classes.GetClassFromName ( ClassName )
 if ref ci <> null then
 mem = malloc (ci.ClassSize)

 if ci.CreateCtrlAddr <> null then
 if mem <> null then
 if ref ci <> null then

   loc_a1 = mem
   loc_a2 = ref Parent
   loc_a3 = ci.CreateCtrlAddr
   asm
      push dd ptr loc_a1
      push dd ptr loc_a2
      call dd ptr loc_a3
      add esp, 4
   end asm

   ret = mem

 end if
 end if
 end if
 end if
return = ret
end function

'// L   v  

'**
'* T    v      .
'*
class ClassLoader: implements Object


' Tvv      
event OnBeforeLoad ( byref Ctrl as Control )
' Tvv      
event OnAfterLoad ( byref Ctrl as Control )
' Tvv    
event OnEventLoad ( byref Ctrl as Control, byval f as file )
event OnStoreProperty ( byref Ctrl as Control, byval PropName as string )


private function _parse (byval Name as string, byval ClassName as string, byval f as file, byval parent as pointer, byref upload as pointer, byval cou as integer) as pointer

 dim byref ctrl as Control
 dim byref par as Control
 set par = parent
 set ctrl = null
 dim ope as boolean = true
 dim opep as boolean = true

 if ref par <> null then
    set ctrl = par.GetControlByName (Name)
    'set ctrl = 0
    'print ctrl.Name, "\n"
 end if
 if ref ctrl = null then
   if upload = null then
    set ctrl = CreateControl (ClassName, par)
    else
    set ctrl = upload
    ope = false
    opep = false
   end if
 end if
 return = 0

 'this.OnBeforeLoad ( ctrl )

    do
      dim text as string = ""
      text = fgets (f, 1024)

      'if feof (f) then 
      '   'msgbox "LOAD OK!" 
      '   exit do
      'end if

      dim s1 as string
      dim cp as integer, ep as integer
      s1 = trim (text)
      cp = instr (0, s1, "CREATE", 0, true)
      ep = instr (0, s1, "END CREATE", 0, true)


      if ep <> -1 then cp = -1




      if cp <> -1 then
         ap% = instr (0, s1, "AS", 0, true)
         if ap <> -1 then
            dim nm as string, cn as string

            nm$ = mid$ (s1, cp + 6, ap - (cp+6))
            nm = trim(nm)
            cn$ = mid$ (s1, ap+2)
            cn$ = trim(cn)

            if ope = true then
               opep = true

               this._parse (nm, cn, f, ref ctrl, 0,cou+1)
            else
               ope = true
            end if


         end if
      end if


      if opep = true then
      dim rp as integer
      rp% = instr (0, s1, "=", 0, true) 
      if rp <> -1 then
         pn$ = trim(mid(s1, 0, rp))
         vl$ = trim(mid(s1, rp+1))
         if ref ctrl <> null then

            dim spp as integer = 0

            if cou = 0 then
            if lcase(pn) = "visible"  then
                  spp = 1
            end if
            end if

            if spp = 0 then
              ctrl.SetProp (pn, vl)

              dim byref lsp as LoaderStoreProperty
              set lsp = new LoaderStoreProperty ()
              lsp.ptr = ref ctrl
              lsp.pn = pn
              Loader_Components_Props.Add ( ref lsp )
              'this.OnStoreProperty (ctrl, pn)
            end if

         end if
      end if
      end if

      if ep <> -1 then 
          cp = -1
          'this.OnAfterLoad ( ctrl )
           Loader_Components.Add ( ref ctrl )
          return = ref ctrl
          exit do
      end if

    loop

end function

'**
'* L CreateControlFromFile    .
'*   𪸠 v, v v  .
'*   v   Control. : <br> 
'* dim byref Form as Form
'* set Form = CreateControlFromFile ("Form1.frm")
'*
public function CreateControlFromFile ( byval FileName as string ) as pointer
LoaderStatus = 1
dim f as file
return = null
Loader_Components.Clear()
dim i as integer, c as integer
c = Loader_Components_Props.Count
for i = 0 to c-1
    dim byref rz as LoaderStoreProperty
    set rz = Loader_Components_Props.Item ( 0 )
    if ref rz <> null then
       delete rz
       Loader_Components_Props.Delete (0)
    end if
next

   f = fopen (FileName, "r")
   if f <> null then

'    do
'      dim txt as string
'      txt = fgets (f, 1024)
'
'      if feof (f) then exit do
'      print txt
'    loop
'exit

    do
      dim text as string
      text = fgets (f, 1024)
      if feof (f) then exit do
      s1$ = trim (text)
      cp% = instr (0, s1, "CREATE", 0, true)

      if cp <> -1 then
         ap% = instr (0, s1, "AS", 0, true)
         if ap <> -1 then
            nm$ = mid$ (s1, cp + 6, ap - (cp+6))
            nm = trim(nm)
            cn$ = mid$ (s1, ap+2)
            cn$ = trim(cn)
            return = this._parse (nm, cn, f, 0, 0, 0)
            dim byref ctrl as Control
            set ctrl = return
            this.OnEventLoad ( ctrl, f )
         end if
      end if
    loop
   end if
LoaderStatus = 0
end function

public function FlipFromFile ( byref ctrl as Control,byval FileName as string ) as pointer
LoaderStatus = 1
Loader_Components.Clear()
dim i as integer, c as integer
c = Loader_Components_Props.Count
for i = 0 to c-1
    dim byref rz as LoaderStoreProperty
    set rz = Loader_Components_Props.Item ( 0 )
    if ref rz <> null then
       delete rz
       Loader_Components_Props.Delete (0)
    end if
next

dim f as file
return = null
   f = fopen (FileName, "r")
   if f <> null then
            return = this._parse (ctrl.Name, ctrl.ClassName, f, 0, ref ctrl, 0)
   end if
LoaderStatus = 0
end function

sub ClassLoader
end class

sub ClassLoader_OnBeforeLoad ( byref Loader as ClassLoader, byref Ctrl as Control ): end sub
sub ClassLoader_OnAfterLoad ( byref Loader as ClassLoader, byref Ctrl as Control ): end sub
sub ClassLoader_OnEventLoad ( byref Loader as ClassLoader, byref Ctrl as Control, byval f as file ): end sub
sub ClassLoader_OnStoreProperty ( byref Loader as ClassLoader, byref Ctrl as Control, byval PropName as string ): end sub

public function CreateControlFromFile ( byval FileName as string ) as pointer

  dim loader as ClassLoader
  return = loader.CreateControlFromFile ( FileName )

end function

public function FlipControlFromFile ( byref ctrl as Control,byval FileName as string ) as pointer
   dim loader as ClassLoader
   return = loader.FlipFromFile ( ctrl, FileName )
end function



sub ClassLoader.ClassLoader ()

    this.OnBeforeLoad = subptr ( ClassLoader_OnBeforeLoad )
    this.OnAfterLoad = subptr ( ClassLoader_OnAfterLoad )
    this.OnEventLoad = subptr ( ClassLoader_OnEventLoad )
    this.OnStoreProperty = subptr ( ClassLoader_OnStoreProperty )
 
end sub





