'*                                                    
'* CustomButton Class                                         
'*
'* Copyright(c) by Metlashevskiy Egor <br>
'*
'*  ,     Button, CheckBox, RadioButton
'*
'*
unit windows.gui.CustomButton

$document "../../../doc/CustomButton.htm"

import windows.gui.Widget

published enum ButtonStates
          BST_UNCHECKED = 0x0000
          BST_CHECKED = 0x0001
          BST_INDETERMINATE = 0x0002
          BST_PUSHED = 0x0004
          BST_FOCUS = 0x0008
end enum

published class CustomButton: implements Widget

published:

      property Multiline as boolean
      property Flat as boolean
      property Checked as ButtonStates
      property State as ButtonStates
public:
      '**
      '*     CustomEdit
      '*
      virtual sub WndProc ( byval hWnd as long, byval Message as long, byval WParam as long, byval LParam as long, byref Ret as boolean )
      end sub


      sub CustomButton ()

end class


sub CustomButton.Multiline ( byref m_Value as boolean )
    if m_Value = true then
      this.AddWndStyle ( BS_MULTILINE )
    else
      this.RemoveWndStyle ( BS_MULTILINE )
    end if
end sub

function CustomButton.Multiline () as boolean
    return = this.IsWndStyle ( BS_MULTILINE )
end function

sub CustomButton.Flat ( byref m_Value as boolean )
    if m_Value = true then
       this.AddWndStyle ( BS_FLAT )
    else
       this.RemoveWndStyle ( BS_FLAT )
    end if
end sub

function CustomButton.Flat () as boolean
    return = this.IsWndStyle ( BS_FLAT )
end function

sub CustomButton.Checked ( byref m_Value as ButtonStates)
    SendMessage ( this.hWnd, BM_SETCHECK, m_Value, 0)
end sub

function CustomButton.Checked () as ButtonStates
    return = SendMessage ( this.hWnd, BM_GETCHECK, 0, 0)
end function

sub CustomButton.State ( byref m_Value as ButtonStates)
    SendMessage ( this.hWnd, BM_SETSTATE, m_Value, 0)
end sub

function CustomButton.State () as ButtonStates
    return = SendMessage ( this.hWnd, BM_GETSTATE, 0, 0)
end function

sub CustomButton.CustomButton ()
end sub




