'*                                                    
'* CustomEdit Class                                         
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.CustomEdit

$document "../../../doc/CustomEdit.htm"

import windows.gui.Widget

published class CustomEdit: implements Widget

published:

      ' 
      property ReadOnly as boolean
      '   
      property readonly MultiLine as boolean
      '   
      property SelStart as integer
      '  
      property SelLength as integer
      '     
      property MaxLength as integer


      '        
      event OnChange ()
public:

      ' true,    
      function CanUndo () as boolean
          return = SendMessage (this.m_wnd, EM_CANUNDO, 0, 0)
      end function

      '**
      '*     CustomEdit
      '*
      virtual sub WndProc ( byval hWnd as long, byval Message as long, byval WParam as long, byval LParam as long, byref Ret as boolean )

          select case Message
          case WM_COMMAND: 
          end select

      end sub
  

      sub CustomEdit ()

end class

private sub Edit_OnChange ( byref Widget as Widget ): end sub

sub CustomEdit.MaxLength ( byref m_MaxLength as integer )
'msgbox str(m_MaxLength)
    SendMessage ( this.Hwnd, EM_LIMITTEXT, m_MaxLength, 0)
end sub

function CustomEdit.MaxLength () as integer
    return = SendMessage ( this.Hwnd, EM_GETLIMITTEXT, 0, 0 )
end function


'**
'*   
'*
function CustomEdit.SelStart () as integer
dim start as dword
dim end as dword
  SendMessage (this.m_wnd, EM_GETSEL, AddressOf(ref start), AddressOf(ref end))
  return = start
end function

sub CustomEdit.SelStart ( byref start as integer )
  SendMessage (this.m_wnd, EM_SETSEL, start, start)
end sub


sub CustomEdit.SelLength ( byref m_Length as integer )
dim start as dword
dim end as dword
  SendMessage (this.m_wnd, EM_GETSEL, AddressOf(ref start), AddressOf(ref end))
  SendMessage (this.m_wnd, EM_SETSEL, start, end+m_Length)
end sub

function CustomEdit.SelLength () as integer
dim start as dword
dim end as dword
  SendMessage (this.m_wnd, EM_GETSEL, AddressOf(ref start), AddressOf(ref end))
  return = end-start
end function


function CustomEdit.MultiLine () as boolean
dim style as long
    style = this.GetWndStyle ()
    return = ( (style and ES_MULTILINE) mod (ES_MULTILINE - 1))
end function

sub CustomEdit.ReadOnly ( byref m_ReadOnly as boolean )
    SendMessage (this.m_wnd, EM_SETREADONLY, m_ReadOnly, 0)
end sub

function CustomEdit.ReadOnly () as boolean
dim style as long
    style = this.GetWndStyle ()
    return = ( (style and ES_READONLY) mod (ES_READONLY-1) )
end function
                                                       
sub CustomEdit.CustomEdit ()
    this.OnChange = subptr ( Edit_OnChange )
end sub



