'*
'* CustomScrollBar Class
'*
'* Copyright(c) 2006 by metlashevskiy Egor
'*
unit windows.gui.CustomScrollBar

$document "../../../doc/CustomScrollBar.htm"

import windows.gui.Widget

published class CustomScrollBar: implements Control

      dim Settings as SCROLLINFO
      dim m_ScrollType as integer
      dim hWnd as integer = null

private:
      dim scid as integer       

      declare sub Accept ()     

published:

      property Min as integer
      property Max as integer
      property Page as integer
      property Pos as integer
      property TrackPos as integer
      property ScrollType as integer


      event OnChange ()

public:

      sub Initialize 
          this.ScrollType = SB_VERT
      end sub

      declare sub GetInfo ()
      declare sub ParentWndProc ( byref Widget as Widget, byval message as long, byval wparam as long, byval lparam as long )


      sub CustomScrollBar ()
      sub CustomScrollBar ( byref m_Parent as Control )


end class

'default events
sub CustomScrollBar_OnChange ( byref Widget as Widget ): end sub

sub CustomScrollBar.ParentWndProc ( byref Widget as Widget, byval message as long, byval wparam as long, byval lparam as long )
    if message = this.scid then

             dim si as SCROLLINFO
             dim p as integer

             si.cbSize = sizeof ( SCROLLINFO ) 
             si.fMask = SIF_ALL
             GetScrollInfo ( Widget.hWnd, this.ScrollType, si) 

             p = si.nPos

             if loword (wparam) = SB_LINERIGHT then si.nPos = si.nPos + 1
             if loword (wparam) = SB_LINELEFT then si.nPos = si.nPos - 1
             if loword (wparam) = SB_TOP then si.nPos = si.nMin
             if loword (wparam) = SB_BOTTOM then si.nPos = si.nMax
             if loword (wparam) = SB_PAGEUP then si.nPos = si.nPos + si.nPage
             if loword (wparam) = SB_PAGEDOWN then si.nPos = si.nPos -si.nPage
             if loword (wparam) = SB_THUMBTRACK then si.nPos = si.nTrackPos

             si.cbSize = sizeof ( SCROLLINFO ) 
             si.Mask = SIF_POS
             SetScrollPos ( Widget.hWnd, this.ScrollType, si.nPos, true)
             GetScrollInfo ( Widget.hWnd, SB_VERT, si) 

             if p <> si.nPos then
                'print "ASD = ", this.GetParentClass()

                this.OnChange ()

                'UpDateWindow (Widget.hWnd)
             end if
 
           'exit

    end if

end sub

function CustomScrollBar.ScrollType () as integer
    return = this.m_ScrollType
end function

sub CustomScrollBar.ScrollType ( byref m_ScrollType as integer )
    this.m_ScrollType = m_ScrollType
    if m_ScrollType = SB_HORZ then this.scid = WM_HSCROLL
    if m_ScrollType = SB_VERT then this.scid = WM_VSCROLL
end sub


sub CustomScrollBar.GetInfo ()

  if this.hWnd <> null then
     this.Settings.cbSize = sizeof (SCROLLINFO)
     this.Settings.fMask = SIF_ALL
     GetScrollInfo ( this.hWnd, this.ScrollType, this.Settings)
  end if

end sub


sub CustomScrollBar.Min ( byref m_Min as integer )
    this.Settings.nMin = m_Min
    this.Accept()
end sub

function CustomScrollBar.Min () as integer
    this.GetInfo ()
    return = this.Settings.nMin
end function

sub CustomScrollBar.Max ( byref m_Max as integer )
    this.Settings.nMax = m_Max
    this.Accept()
end sub

function CustomScrollBar.Max () as integer
    this.GetInfo ()
    return = this.Settings.nMax
end function

sub CustomScrollBar.Page ( byref m_Page as integer )
    this.Settings.nPage = m_Page
    this.Accept()
end sub

function CustomScrollBar.Page () as integer
    this.GetInfo ()
    return = this.Settings.nPage
end function

sub CustomScrollBar.Pos ( byref m_Pos as integer )
    this.Settings.nPos = m_Pos
    this.Accept()
end sub

function CustomScrollBar.Pos () as integer
    this.GetInfo ()
    return = this.Settings.nPos
end function

sub CustomScrollBar.TrackPos ( byref m_TrackPos as integer )
    this.Settings.nTrackPos = m_TrackPos
    this.Accept()
end sub

function CustomScrollBar.TrackPos () as integer
    this.GetInfo ()
    return = this.Settings.nTrackPos
end function


sub CustomScrollBar.Accept ()
    this.Settings.cbSize = sizeof ( SCROLLINFO )
    this.Settings.fMask = SIF_ALL
    'SetScrollInfo ( this.hWnd, this.ScrollType, this.Settings, true )
end sub

sub CustomScrollBar.CustomScrollBar ()
    this.Initialize()
    this.OnChange = subptr ( CustomScrollBar_OnChange )
end sub

sub CustomScrollBar.CustomScrollBar ( byref Parent as Control )
    this.CustomScrollbar()
    this.ParentControl = Parent
end sub

