'*                                                    
'* Inspector Class                                         
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.Inspector

$document "../../../doc/Inspector.htm"

import windows.gui.Widget
import windows.gui.Edit
import windows.gui.ColorDialog
import windows.gui.CustomScrollBar
import windows.gui.ComboBox
import windows.gui.OpenSaveDialog

import lang.classes


$include "commctrl.inc"

declare sub Inspector_OnPaint ( byref Insp as Widget )
declare sub Inspector_OnMouseDown ( byref Sender as Widget, byval Button as long, byval Shift as long, byval X as long, byval Y as long )
declare sub Edit_OnKeyPress ( byref Edit as Edit, byval KeyAscii as integer )
declare sub Inspector_OnScroll ( byref Scroll as CustomScrollBar )
declare sub Combo_OnChange ( byref c as ComboBox )






published class Inspector: implements Widget ()

      dim Edit as pointer = null
      dim CurPi as pointer = null
      dim CurCon as pointer = null
      dim CDialog as ColorDialog (this)
      dim VScroll as CustomScrollBar (this)
      dim Combo as pointer = null
      dim CurEI as pointer = null

      dim RealHeight as integer = this.Height
      dim Up as integer = 0

private:
      dim m_ControlRef as pointer = null

public:
      property ControlRef as pointer
      

      sub Inspector ( byref Widget as Widget )

      private sub Initialize ()
          dim exStyle as long
          this.Caption = "Inspector"
          this.OnPaint = subptr ( Inspector_OnPaint )
          this.OnMouseDown = subptr ( Inspector_OnMouseDown)
          'this.Edit.Show()
          'this.Edit.Visible = true
      end sub

      '**
      '* ⥫ ࠡ稪 ᮡ⨩  Inspector
      '*
      virtual sub WndProc ( byval hWnd as long, byval Message as long, byval WParam as long, byval LParam as long, byref Ret as boolean )

          select case Message
          case WM_COMMAND: 
          case WM_PAINT:
          case WM_VSCROLL:
               this.VScroll.ParentWndProc ( this, Message, wparam, lparam )

         end select
         ret = false
      end sub

      published event OnPropertyChanged ( byref ctrl as Control, byref pi as PropertyInfo )

end class


sub Inspector.ControlRef ( byref ptr as pointer )
    dim byref w as Widget
    set w = this.Edit
    w.Visible = false
    set w = this.Combo
    w.Visible = false
    this.CurPI = 0
    this.CurEI = 0
    this.Up = 0
    this.m_ControlRef = ptr
    this.OnPaint ()
end sub

function Inspector.ControlRef () as pointer
    return = this.m_ControlRef
end function


private i_y as integer
private i_mx as integer
private i_my as integer
private i_dtitle as integer

private sub Inspector_OnPropertyChanged ( byref sender as Control, byref ctrl as Control, byref pi as PropertyInfo ): end sub



private function Drw_Props ( byval PropertyName as string, byval ClassName as string, byref ctrl as Control, byref Insp as Inspector, byval style as integer) as pointer
dim btnface as color = (GetSysColor(COLOR_BTNFACE))

       dim ret as pointer = null
       dim i as integer, c as integer
       dim byref ci as ClassInfo
       dim Hi as integer = 17
       dim Bord as integer = 15

       set ci = classes.GetClassFromName ( ClassName )

       if ref ci <> null then
       c = ci.propertys.count


       if i_dtitle = 1 then
           dim ry as integer = ((i_y+1) * hi) + Insp.Up

       if style = 0 then

           Insp.Canvas.Pen.Color = 0xCCCCCC
           Insp.Canvas.Pen.Style = PS_SOLID

           Insp.Canvas.Line (bord,ry,Insp.Width,ry)

           Insp.Canvas.Pen.Style = PS_NULL
           Insp.Canvas.Brush.Color = btnface
           Insp.Canvas.Rectangle (bord+1,ry-(hi-1),Insp.Width,ry)

           Insp.Canvas.Font.Style= fsBold

           Insp.Canvas.TextColor = 0x0000FF
           Insp.Canvas.TextOut (bord+5, ry-(hi-2), PropertyName)
           Insp.Canvas.TextColor = 0
           'Insp.Canvas.TextOut (120, ry-18, pi.GetValue(ctrl))
       end if
           i_y = i_y + 1
       end if



       i_dtitle = 0
       
       if c > 0 then
          for i = 0 to c-1
          dim byref pi as PropertyInfo
          set pi = ci.propertys.item (i)
          'if pi.Name = PropertyName then




       dim ry as integer = ((i_y+1) * hi) + Insp.Up

       'Paint insector data
       if style = 0 then
           Insp.Canvas.BackStyle = Transparent
           Insp.Canvas.Pen.Color = 0xCCCCCC
           Insp.Canvas.Pen.Style = PS_SOLID

           Insp.Canvas.Line (bord,ry,Insp.Width,ry)

           dim r as rect
           r.left = 25
           r.top = ry-19
           r.right = r.left + 60
           r.bottom = r.top + 20

           'inValidateRect (Insp.hWnd, r, 0)

           dim byref ei2 as EnumInfo
           set ei2 = enums.GetEnumByName (pi.DataType)

           if (lcase(pi.DataType) = "color") then
           else
             Insp.Canvas.Font.Style= 0
             Insp.Canvas.TextOut (bord+5, ry-(hi-2), pi.Name)

             if ref ei2 = null then
               Insp.Canvas.TextOut (120, ry-(hi-2), pi.GetValue(ctrl))
             else
               dim v as string = pi.GetValue (ctrl)
               dim prt as string = ei2.GetConstNameFromValue (v)
               Insp.Canvas.TextOut (120, ry-(hi-2), prt)

             end if

           end if

           if lcase(pi.DataType) = "color" then

             Insp.Canvas.Font.Style= 0
             Insp.Canvas.TextOut (bord+5, ry-(hi-2), pi.Name)

             Insp.Canvas.Brush.Color = Val(pi.GetValue(ctrl))
             Insp.Canvas.Rectangle (120, ry-(hi-5), 134, ry-3)
             Insp.Canvas.TextOut (137, ry-(hi-4), hex(val(pi.GetValue(ctrl))))




           end if

           'print str(i_y), "\n"
       end if


       'Mouse
       if style = 1 then

          dim byref Edit as Edit
          set Edit = Insp.Edit
          dim byref Combo as ComboBox
          set Combo = Insp.Combo

          if (i_my > (ry-20)) and (i_my < (ry)) then

 
           if (lcase(pi.DataType) = "color") then
           else

           if enums.GetEnumByName ( pi.DataType ) = null then


             Edit.OnKeyPress = subptr ( Edit_OnKeyPress )
             Edit.BorderStyle = bsNone
             Edit.Show()
             Edit.Move (123-3, ry-(hi-2), Insp.Width-125,(hi-2))
             Edit.Caption = pi.GetValue(ctrl)
             Insp.CurPI = ref pi
             Insp.CurCon = ref ctrl
             Combo.Visible = false

             if pi.Name = "FileName" then

                dim Dlg as OpenSaveDIalog (Edit)
                Dlg.FileName = ""
                if Dlg.ShowOpen() then

                if not (Dlg.FileName = "") then
                   Edit.Visible = false
                   pi.SetValue ctrl, Dlg.FileName
                   insp.OnPropertyChanged ( ctrl, pi )
                 
                end if

                end if

             end if

           else

             Edit.Visible = false
             dim byref ei as EnumInfo
             set ei = enums.GetEnumByName (pi.DataType)
             Combo.BorderStyle = bsNone
             Combo.OnChange = subptr ( Combo_OnChange )
             Combo.Show()
             Combo.Move (123-4, ry-(hi-1), Insp.Width-125-10,185)
             Combo.Caption = ei.GetConstNameFromValue (pi.GetValue(ctrl))
             Combo.Clear
             dim i3 as integer, c3 as integer
             c3 = ei.Constants.Count
             for i3 = 0 to c3-1
                 dim byref ci3 as ConstInfo
                 set ci3 = ei.Constants.Item (i3)
                 Combo.AddItem ( ci3.Name  )
                 'msgbox ci3.Name
             next
             Combo.Visible = true
             Insp.CurPI = ref pi
             Insp.CurCon = ref ctrl
             Insp.CurEI = ref ei
           end if

           end if
           if lcase(pi.DataType) = "color" then
              if Insp.CDialog.Show then
                 pi.SetValue (ctrl, str(Insp.CDialog.Color))
                 Insp.OnPropertyChanged ( ctrl, pi )

              end if
           end if

'Edit.Brush.Color = 1123112312   
 
         'Edit.Refresh

             'Insp.Canvas.Rectangle (0,ry-20,45,ry)
              'msgbox "f"


          end if

          'msgbox str(i_mx)


       end if

           i_y = i_y + 1
           Insp.RealHeight = i_y * hi

          'end if
          next
       end if
       end if

       if ref ci <> null then
       if ret = null then
       if not (ci.ImplementClass = "") then
          ret = Drw_Props ( PropertyName, ci.ImplementClass, ctrl, Insp, style )

       end if
       end if
       end if
       return = ret
end function


sub dr_acc (byval SCa as string, byval ClassName as string, byref Ctrl as Control, Insp as Inspector, byval f as integer )
    dim i as integer, c as integer
    c = ctrl.GetControlCount
    if c > 0 then
       for i = 0 to c-1
           dim byref sc as Control
           set sc = ctrl.GetControl (i)
           if sc.IsImplement ("Widget") = false then
              i_dtitle = 1
              Drw_Props (SCa + "." + sc.Name, sc.ClassName, sc, Insp, f)
              if sc.GetControlCount > 0 then
                 dr_acc (sc.Name, sc.ClassName, sc, Insp, f )
              end if
           end if
       next
    end if
end sub


sub Inspector_OnMouseDown ( byref Insp as Inspector, byval Button as long, byval Shift as long, byval X as long, byval Y as long )

 if Insp.ControlRef <> null then
    dim byref ctrl as Control
    set ctrl = Insp.ControlRef
    Insp.RealHeight = 0

    i_y = 0
    i_mx = x
    i_my = y
    Drw_Props ("", ctrl.ClassName, ctrl, Insp, 1)
    dr_acc ("", ctrl.ClassName, ctrl, Insp, 1)

 end if 


end sub

sub Edit_OnKeyPress ( byref Edit as Edit, byval KeyAscii as integer )
if keyascii = 13 then

'   dim byref 

   dim byref insp as Inspector
   dim byref ctrl as Control
   set insp = Edit.GetParentClass

   if insp.Curpi <> null then
      set ctrl = insp.CurCon
      if ref ctrl <> null then

        dim byref pi as PropertyInfo
        set pi = insp.Curpi
        pi.SetValue ctrl, Edit.Caption
        insp.OnPropertyChanged ( ctrl, pi )

      end if
   end if
end if

end sub

sub Inspector_OnPaint ( byref Insp as Inspector )
if Insp.Visible = true then
dim w as integer, h as integer
dim ps as PAINTSTRUCT
'BeginPaint (Insp.hWnd, ps)
w = Insp.Width
h = Insp.Height
'Insp.Canvas.Pen.Color = 1232
with Insp.Canvas

dim btnface as color = (GetSysColor(COLOR_BTNFACE))
Insp.RealHeight = 0

       dim Hi as integer = 17
       dim Bord as integer = 15



 .Brush.Color = btnface
 .Brush.Color = 0xFFFFFF
 .Pen.Style = PS_NULL
 .Rectangle (0,0,w,h)

 '.Brush.CreateSolidBrush (GetSysColor(COLOR_BTNFACE))
 .Brush.Color = btnface
 .Rectangle (0,0,bord,h)

 .Pen.Style = PS_SOLID
 .Pen.Color = 0xAAAAAA
 .Line (bord,0,bord,h)

 .Pen.Style = PS_SOLID
 .Pen.Color = 0xCCCCCC
 .Line (110+5,0,110+5,h)

end with

 if Insp.ControlRef <> null then
    dim byref ctrl as Control
    set ctrl = Insp.ControlRef
    i_y = 0
    Drw_Props ("", ctrl.ClassName, ctrl, Insp, 0)
    dr_acc ("", ctrl.ClassName, ctrl, Insp, 0)




 end if 
'EndPaint (Insp.hWnd, ps)
end if
end sub

sub Combo_OnChange ( byref c as ComboBox )
if c.ListIndex <> -1 then
dim byref w as Inspector
set w = c.GetParentClass ()

if ref w <> null then

   dim byref ei as EnumInfo
   dim byref ci as ConstInfo
   set ei = w.CurEI
   set ci = ei.Constants.Item (c.ListIndex)

   if w.Curpi <> null then
      dim byref ctrl as Control
      set ctrl = w.CurCon
      if ref ctrl <> null then

        dim byref pi as PropertyInfo
        set pi = w.Curpi
        pi.SetValue ctrl, ci.Value
        w.OnPropertyChanged ( ctrl, pi )
      end if
   end if


   'pi.SetValue
   'print c.ListIndex

end if
end if


end sub

sub Inspector_OnScroll ( byref Scroll as CustomScrollBar )
'print Scroll.GetParentClass()
dim byref w as Inspector
set w = Scroll.GetParentClass ()
if w.RealHeight > w.ClientHeight then

   dim byref Edit as Edit
   set Edit = w.Edit
   Edit.Visible = false

   dim byref Combo as ComboBox
   set Combo = w.Combo
   Combo.Visible = false

   w.Up = - ((w.RealHeight - w.ClientHeight)) * (w.VScroll.Pos / 100)
end if
Inspector_OnPaint ( w )
end sub

sub Inspector.Inspector ( byref Widget as Widget )
    this.ParentControl = Widget
    this.CreateWindow( WS_CHILD or WS_OVERLAPPED or WS_CLIPCHILDREN or WS_VSCROLL,  100,100,400,300, Widget.hWnd, null )
    this.Initialize()

    this.Edit = CreateControl ("Edit", this)
    this.Combo = CreateControl ("ComboBox", this)

    dim byref c as ComboBox
    set c = this.Combo
    c.Name = "ComboBox"

    this.VScroll.hWnd = this.hWnd
    this.VScroll.ScrollType = SB_VERT
    this.VScroll.OnChange = subptr ( Inspector_OnScroll )
    this.BorderStyle = bsSoft
    this.VScroll.Name = "VScroll"
    this.CDialog.Name = "ColorDialog"
    this.VScroll.ChildClass = true
    this.CDialog.ChildClass = true

    this.OnPropertyChanged = subptr ( Inspector_OnPropertyChanged )

end sub

sub InitLibrary
    RegisterClass ("Inspector", subptrclass ( Inspector, Inspector) )
end sub




