'*                                                    
'* Menu Class                                         
'*
'* Copyright(c) by Metlashevskiy Egor
'*
'*       
'* MainMenu, MenuItem, PopupMenu
'*
'*  MainMenu -      
'*  MenuItem -  ,   ,    
'*  PopupMenu -  
'*
'*
unit windows.gui.Menu

$document "../../../doc/Menu.htm"


import windows.gui.Widget

private menu_countid as integer = 0 '     (ID),     
                                    '    
'**
'* MenuItem 
'*
'*  ,  
'*
published class MenuItem: implements Control
private:
      dim m_menu as pointer = null  '    (hMenu)
      dim m_items as Collection()   '    
      dim m_pos as integer = 0      '      ()
      dim m_id as integer = 0
public:

      '    (hMenu)
      property hMenu as long        


      '  
      published property Caption as string    

      '  
      private property readonly Id as integer

      '   
      published event OnClick ()

      '**
      '*  
      '*
      declare sub AddItem ( byref MenuItem as MenuItem )

      '**
      '*    
      '*
      function Count () as integer
          return = this.m_items.count()
      end function

      '**
      '*    MenuItem
      '*
      declare function GetMenuById ( byval Id as integer ) as pointer

      private declare sub Initialize ()

      sub MenuItem ()
      sub MenuItem ( byref Parent as MenuItem )
end class

sub MenuItem_OnClick ( byref Menu as MenuItem ): end sub


function MenuItem.Id () as integer
    return = this.m_id
end function

function MenuItem.GetMenuById ( byval Id as integer ) as pointer
dim i as integer, c as integer
dim ret as pointer = 0

    c = this.GetControlCount
    if c > 0 then
       for i = 0 to c-1

           dim byref mi as MenuItem
           set mi = this.GetControl ( i )
           if mi.id = Id then
              ret = ( set mi )
           else
              dim fv as pointer
              fv = mi.GetMenuById ( Id )
              if fv <> 0 then ret = fv
           end if
       next

    end if
    return = ret

end function

sub MenuItem.Caption ( byref m_Caption as string )
if (this.GetParentClass() <> null) then

  dim byref MI as MenuItem
  set MI = this.GetParentClass()

  dim MII as MENUITEMINFO
  memset ref MII, 0 , sizeof(MENUITEMINFO)
  MII.cbSize = sizeof ( MENUITEMINFO )
  MII.fMask = MIIM_ID Or MIIM_TYPE
  MII.fType = MFT_STRING


  GetMenuItemInfo ( MI.hMenu, this.m_pos, 1, MII)

  if m_Caption = "-" then
     MII.ftype = MFT_SEPARATOR or MFT_STRING
  end if

  dim a as AnsiString (m_Caption)
  MII.dwTypeData = AddressOf(a.data)
  MII.cch = a.Length()
  SetMenuItemInfo ( MI.hMenu, this.m_pos, 1, MII)

end if
end sub

function MenuItem.Caption () as string
if (this.GetParentClass() <> null) then
  dim byref MI as MenuItem
  set MI = this.GetParentClass()
  dim st as pointer
  st = malloc (1024)
  GetMenuString ( MI.hMenu, this.m_pos, AddressOf (st), 1024, MF_BYPOSITION )
  return = CharToStr (st)
end if
end function

sub MenuItem.AddItem ( byref MenuItem as MenuItem )
dim lpstr as string
dim flags as integer
'dim insert as integer = -1

    lpstr = "MenuItem" + str(menu_countid)
    'insert = menu_countid
    flags = MF_BYCOMMAND
    MenuItem.m_pos = this.m_items.Count

    if this.GetParentClass <> null then
       dim byref MI as MenuItem
       set MI = this.GetParentClass()
       'ModifyMenu MI.hMenu, this.m_pos, flags or MF_POPUP, this.hMenu, this.Caption
       dim sMI as MENUITEMINFO
       memset (ref sMI, 0, sizeof (MENUITEMINFO))
       with smi
            .cbSize = sizeof(MENUITEMINFO)
            .fMask =  MIIM_ID or MIIM_TYPE
            '.fMask =  MIIM_TYPE
            .fType = MFT_STRING 
            GetMenuItemInfo ( MI.hMenu, this.m_pos, 1, sMi)
            .fMask = .fMask or MIIM_SUBMENU
            .hSubMenu = this.hMenu
            dim a as AnsiString (this.Caption)
            .dwTypeData = AddressOf (a.Data)
            .cch = a.Length() 

       end With       
       SetMenuItemInfo(MI.hMenu, this.m_pos, 1, sMi)
    end if

    dim MII as MENUITEMINFO
    memset (ref MII, 0, sizeof (MENUITEMINFO))
    With mii
            .cbSize = sizeof(MENUITEMINFO)
            .fMask = MIIM_ID Or MIIM_TYPE
            .fType = MFT_STRING 
            .wID = control_countid

            if MenuItem.Count > 0 then

               .fMask = .fMask or MIIM_SUBMENU
               .hSubMenu = MenuItem.hMenu

            end if

            dim a as AnsiString (lpstr)
            .dwTypeData = AddressOf (a.Data)
            .cch = len(lpstr)
    End With       

    InsertMenuItem(this.hMenu, MenuItem.m_pos, 1, mii)


    if MenuItem.Count > 0 then
    else
    end if

    MenuItem.m_id = control_countid
    this.m_items.add ( ref MenuItem )
    MenuItem.ParentControl = this
    control_countid = control_countid + 1

end sub

sub MenuItem.Initialize ()
    this.OnClick = subptr ( MenuItem_OnClick )
end sub

sub MenuItem.hMenu ( byref Menu as long )
    this.m_menu = Menu
end sub

function MenuItem.hMenu () as long
    return = this.m_menu
end function

sub MenuItem.MenuItem ( byref Parent as MenuItem )
    this.Initialize ()
    this.m_menu = CreateMenu()
    Parent.AddItem ( this )
end sub

sub MenuItem.MenuItem ()
    this.Initialize ()
    this.m_menu = CreateMenu()
end sub

'**
'* MainMenu
'*
published class MainMenu: implements MenuItem ()
public:

      '  (  )    
      property Parent as Widget

      ' Widget -      
      sub MainMenu ( byref Widget as Widget )

      ' 
      private sub Initialize ()
      end sub

end class

sub MainMenu.Parent ( byref Widget as Widget )
    this.m_parent = ref Widget
    Widget.MainMenu = ref this
    SetMenu (Widget.hWnd, m_menu)
end sub

function MainMenu.Parent () as Widget
dim byref W as Widget
    set W = this.m_parent
    return = W
end function

'sub MainMenu.MainMenu ()
'end sub

sub MainMenu.MainMenu ( byref Widget as Widget )
    this.ParentControl = Widget
    this.m_menu = CreateMenu()
    this.Initialize()
    this.Parent = Widget
end sub

sub InitLibrary

    RegisterClass ( "MainMenu", subptrclass ( MainMenu, MainMenu ) )
    RegisterClass ( "MenuItem", subptrclass ( MenuItem, MenuItem ) )



end sub
