'*
'* OpenSaveDialog Class
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.OpenSaveDialog

$document "../../../doc/OpenSaveDialog.htm"

import windows.gui.Control
import windows.gui.Widget


published class OpenSaveDialog: implements Control


private:
      dim m_Title as string
      dim m_InitDir as string
      dim m_Filter as string
      dim m_FileName as string
      dim m_FileTitle as string
      dim m_Func as integer = 0

public:
      dim Settings as OPENFILENAME

published:

      '  
      property Title as string
      '   
      property InitDir as string
      ' 
      property Filter as string
      '     
      property FileName as string
      '      
      property FileTitle as string


public:
      '  ,  true,   
      declare function ShowOpen () as boolean
      declare function ShowSave () as boolean


      sub OpenSaveDialog ( byref Control as Control )

end class


function OpenSaveDialog.ShowSave () as boolean

  this.m_Func = 1
  this.ShowOpen ()

end function

function OpenSaveDialog.ShowOpen () as boolean

 dim c_file as pointer = malloc (1024)
 dim c_filetitle as pointer = malloc (1024)

 memset (ref this.settings, 0, sizeof(OPENFILENAME))

 dim a1 as AnsiString (this.Filter)
 dim a2 as AnsiString (this.InitDir)
 dim a3 as AnsiString (this.Title)


 with this.Settings

    .lStructSize = sizeof(OPENFILENAME)

    dim byref w as Widget
    set w = this.GetParentClass
    if ref w <> null then
    if w.IsImplement ("Widget") then

    .hwndOwner = w.hwnd

    end if
    end if

    'Set the application's instance
    .hInstance = GetModuleHandle (0)
    'Set the filet

    .lpstrFilter = AddressOf ( a1.Data )

    'Create a buffer
    .lpstrFile = AddressOf ( c_file )
    'Set the maximum number of chars
    .nMaxFile = 1024
    'Create a buffer
    .lpstrFileTitle = AddressOf ( c_filetitle )
    'Set the maximum number of chars
    .nMaxFileTitle = 1024
    'Set the initial directory

    .lpstrInitialDir = AddressOf ( a2.Data )
    'Set the dialog title
    .lpstrTitle = AddressOf ( a3.Data )
    .flags = 0
 end with


 if m_Func = 0 then
   return = GetOpenFileName(this.settings) 
 end if
 if m_Func = 1 then
   return = GetSaveFileName(this.settings) 
 end if


 this.FileName = ""
 this.FileTitle = ""

 if return = true then

    this.FileName = CharToStr ( c_file )
    this.FileTItle = CharToStr ( c_filetitle )

 end if

 mfree ( c_file )
 mfree ( c_filetitle )

 m_Func = 0

end function


sub OpenSaveDialog.Title ( byref m_Title as string )
    this.m_Title = m_Title
end sub

function OpenSaveDialog.Title () as string
    return = this.m_Title
end function

sub OpenSaveDialog.InitDir ( byref m_InitDir as string )
   this.m_InitDir = m_InitDir
end sub

function OpenSaveDialog.InitDir () as string
    return = this.m_InitDir
end function

sub OpenSaveDialog.Filter ( byref m_Filter as string )
    this.m_Filter = m_Filter
end sub

function OpenSaveDialog.Filter () as string
    return = this.m_Filter
end function

sub OpenSaveDialog.FileName ( byref m_FileName as string )
    this.m_FileName = m_FileName
end sub

function OpenSaveDialog.FileName () as string
    return = this.m_FileName
end function

sub OpenSaveDialog.FileTitle ( byref m_FileTitle as string )
    this.m_FileTitle = m_FileTitle
end sub

function OpenSaveDialog.FileTitle () as string
    return = this.m_FileTitle
end function



sub OpenSaveDialog.OpenSaveDialog ( byref Control as Control )
    this.ParentControl = Control
    'this.Caption = "OpenSaveDialog"
end sub

sub InitLibrary

    'RegisterClass ( "OpenSaveDialog", subptrclass ( OpenSaveDialog, OpenSaveDialog ) )

end sub
