'*
'* Pen Class
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.Pen

$document "../../../doc/Pen.htm"

import windows.gui.Control

published class Pen: implements Control
private:
      dim m_Pen as pointer = null
public:
      dim LogPen as LOGPEN

      property hPen as long

published:

      property Color as long
      property Style as long
      property Width as long

      event OnChange ()

public:

      declare sub Refresh ()
      sub Pen ( byref Parent as Control )
end class

'default events
private sub Pen_OnChange ( byref Pen as Pen ): end sub

sub Pen.Color ( byref m_Color as long )
   this.LogPen.lopnColor = m_Color
   this.Refresh()
   this.OnChange()
end sub

function Pen.Color () as long
   return = this.LogPen.lopnColor
end function

sub Pen.Style ( byref m_Style as long )
   this.LogPen.lopnStyle = m_Style
   this.Refresh()
   this.OnChange()
end sub

function Pen.Style () as long
   return = this.LogPen.lopnStyle
end function

sub Pen.Width ( byref m_Width as long )
   this.LogPen.lopnWidth.x = m_Width
   this.LogPen.lopnWidth.y = m_Width
   this.Refresh()
   this.OnChange()
end sub

function Pen.Width () as long
   return = this.LogPen.lopnWidth.x 
end function


sub Pen.hPen ( byref m_hPen as long )
   this.m_Pen = m_hPen
end sub

function Pen.hPen () as long
  return = this.m_Pen
end function

sub Pen.Refresh ()
  if m_Pen <> null then
     DeleteObject ( m_Pen )
  end if
  this.m_Pen = CreatePenIndirect (this.LogPen)
end sub

sub Pen.Pen ( byref Parent as Control )

  this.ParentControl = Parent

  with this.logPen
    .lopnColor = 0
    .lopnStyle = PS_SOLID 
    .lopnWidth.x = 1
    .lopnWidth.y = 1

  end with

  this.OnChange = subptr ( Pen_OnChange )

end sub



sub InitLibrary

    RegisterClass ( "Pen", subptrclass ( Pen, Pen ) )

end sub
