'*                                                    
'* ProgressBar Class                                         
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.ProgressBar

$document "../../../doc/ProgressBar.htm"

import windows.gui.Widget

published class ProgressBar: implements Widget

      declare sub Initialize ()
      sub ProgressBar ( byref Widget as Widget )

      dim BarColor as Brush ( this )

published:
      property Min as integer
      property Max as integer
      property Pos as integer

public:
      sub SetRange ( byval Min as integer, byval Max as integer )
          SendMessage ( this.hWnd, PBM_SETRANGE32, Min, Max)
      end sub

      sub GetRange ( byref Min as integer, byref Max as integer )
          dim range as PBRANGE
          SendMessage ( this.hWnd, PBM_GETRANGE, false, AddressOf (ref range))
          Min = range.iLow
          Max = range.iHigh
      end sub


end class

private event Progress_Brush_OnChange ( byref Brush as Brush )
dim parent as long = Brush.GetParentClass()
if parent <> null then
   dim byref w as Widget
   set w = parent
   SetClassLong w.m_wnd, GCL_HBRBACKGROUND, Brush.hBrush
   SendMessage ( w.hWnd, PBM_SETBKCOLOR, 0, Brush.Color)

   w.Refresh
end if
end sub

private event Progress_BarColor_OnChange ( byref Brush as Brush )
dim parent as long = Brush.GetParentClass()
if parent <> null then
   dim byref w as Widget
   set w = parent
   SendMessage ( w.hWnd, PBM_SETBARCOLOR, 0, Brush.Color)
   w.Refresh
end if
end sub

sub ProgressBar.Initialize ()
    this.Caption = "ProgressBar"
    this.BarColor.Name = "BarColor"
    this.BarColor.ChildClass = true
    this.Brush.OnChange = subptr ( Progress_Brush_OnChange )
    this.BarColor.OnChange = subptr ( Progress_BarColor_OnChange )
    'this.BarColor.Color = 0xFF0000

    'this.BorderStyle = bsSingle
    'this.AddWndExStyle WS_EX_CLIENTEDGE
end sub


sub ProgressBar.ProgressBar ( byref Widget as Widget )
    this.ParentControl = Widget
    cyVScroll = GetSystemMetrics(SM_CYVSCROLL) 
    'this.ControlId = 0
    this.CreateControl ( "msctls_progress32", WS_CHILD or WS_VISIBLE, 10, 10, 90, cyVScroll, Widget.hWnd )
    this.Initialize()
end sub

sub ProgressBar.Min ( byref m_Value as integer )
    dim x as integer, y as integer
    this.GetRange (x,y)
    x = m_Value
    this.SetRange (x,y)
end sub

function progressBar.Min () as integer
    dim x as integer, y as integer
    this.GetRange (x,y)
    return = x
end function

sub ProgressBar.Max ( byref m_Value as integer )
    dim x as integer, y as integer
    this.GetRange (x,y)
    y = m_Value
    this.SetRange (x,y)
end sub

function progressBar.Max () as integer
    dim x as integer, y as integer
    this.GetRange (x,y)
    return = y
end function

sub ProgressBar.Pos ( byref m_Value as integer )
    SendMessage (this.hWnd, PBM_SETPOS, m_Value, 0)
end sub

function progressBar.Pos () as integer
    return = SendMessage (this.hWnd, PBM_GETPOS, 0, 0)
end function




sub InitLibrary

    RegisterClass ( "ProgressBar", subptrclass ( ProgressBar, ProgressBar ) )

end sub


