'*                                                    
'* TabControl Class                                         
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.TabControl

$document "../../../doc/TabControl.htm"

import windows.gui.Widget
$include "commctrl.inc"

'private tc_inc as integer = 0


published class TabSheet: implements Control
private:
       dim m_caption as string

published:
      property Caption as string

public:

      dim Info as TCITEM


          declare sub InsertToTab ( byref Tab as Control )
          sub TabSheet ( byref Control as Control )
end class



published class TabControl: implements Widget ()
published:
      property TabIndex as integer
      event OnChange ()
      event OnChanging ()

public:
      declare sub Initialize ()

      virtual sub WndProc ( byval hWnd as long, byval Message as long, byval WParam as long, byval LParam as long, byref Ret as boolean )
      end sub

      sub TabControl ( byref Widget as Widget )


end class

private sub TabControl_OnChange ( byref Widget as Widget ): end sub
private sub TabControl_OnChanging ( byref Widget as Widget ): end sub

sub TabControl.Initialize ()
    this.Caption = "TabControl"
    this.OnChange = subptr ( TabControl_OnChange )
    this.OnChanging = subptr ( TabControl_OnChanging )
end sub

sub TabControl.TabControl ( byref Widget as Widget )
    this.ParentControl = Widget
    this.CreateControl ( "SysTabControl32", WS_CHILD or TCS_TABS or WS_CLIPSIBLINGS or WS_VISIBLE,, 10, 10, 90, 30, Widget.hWnd )
    this.Initialize()
end sub


sub TabSheet.InsertToTab ( byref Control as Control )
dim byref TC as TabControl
set TC = ref Control
  if ref TC <> null then
     memset (ref Info, 0, sizeof (TCITEM))
     Info.mask = TCIF_TEXT or TCIF_IMAGE
     Info.iImage = -1
     dim a as AnsiString ("TabSheet")
     Info.pszText = AddressOf (a.Data)
     Info.cchTextMax = a.Length()
     this.ControlId = SendMessage (TC.hWnd, TCM_INSERTITEM, this.ControlId, AddressOf ( ref Info ))
     this.Caption = "TabSheet" + str(this.ControlId)
  end if
end sub


sub TabSheet.TabSheet ( byref Control as Control )
    if Control.IsImplement ("TabControl") then
       this.ParentControl = Control
       this.InsertToTab ( Control )
    else
       msgbox "The parent of TabSheet can be TabControl!"
    end if
end sub

sub TabSheet.Caption ( byref Text as string )

    dim byref TC as TabControl
    set TC = this.GetParentClass ()
    memset (ref Info, 0, sizeof (TCITEM))
    Info.mask = TCIF_TEXT or TCIF_IMAGE

    dim a as AnsiString (Text)
    Info.pszText = AddressOf (a.Data)
    Info.cchTextMax = a.Length()-1
    Info.iImage = -1
    SendMessage (TC.hWnd, TCM_SETITEM, this.ControlID, AddressOf ( ref Info ))
    this.m_caption = Text

end sub

function TabSheet.Caption () as string
    return = this.m_caption
end function

sub TabControl.TabIndex ( byref Index as integer )
    SendMessage ( this.hWnd, TCM_GETCURSEL, Index, 0)
end sub

function TabControl.TabIndex () as integer
    return = SendMessage ( this.hWnd, TCM_GETCURSEL, 0, 0)
end function


sub InitLibrary

    RegisterClass ( "TabControl", subptrclass ( TabControl, TabControl ) )
    RegisterClass ( "TabSheet", subptrclass ( TabSheet, TabSheet ) )

end sub

