'*
'* TreeView Classe's
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.TreeView

$document "../../../doc/TreeView.htm"

import windows.gui.Widget

$include "commctrl.inc"

'Node support class
published class Node: implements Control
private:
      'dim m_id as integer = 0
      dim m_handle as integer = null

public:

      '     TreeView
      'property readonly Id as integer
      property readonly hTreeView as integer

published:

      property Text as string
                      
public:

      declare sub Add ( byref Node as Node )
      sub Node ( byref Control as Control )

      
      virtual sub Free ()

       if this.hTreeView <> null then
       if this.ControlId <> null then

          dim byref w as Widget
          set w = this.hTreeView

          SendMessage w.hWnd, TVM_DELETEITEM, 0, this.ControlId


       end if
       end if


      end sub

end class


sub Node.Add ( byref Node as Node )

    dim byref w as Widget
    dim ti as TV_INSERTSTRUCT
    dim t as TV_ITEM

    memset ( ref ti, 0, sizeof(TV_INSERTSTRUCT) )
    memset ( ref t, 0, sizeof(TV_ITEM) )

    set w = this.hTreeView
    Node.m_handle = this.hTreeView

    'w.Left = 100
    '---
    dim a as AnsiString ("Root")

    ti.hParent = this.ControlId

    if ti.hParent then
        t.mask        = TVIF_CHILDREN OR TVIF_HANDLE
        t.hItem       = ti.hParent
        t.cchildren   = 1
        SendMessage (w.hWnd, TVM_SETITEM, 0, AddressOf ( ref t ))
    else
        ti.hInsertAfter = TVI_LAST
        ti.item.cChildren = 0
    end if

    ti.item.mask = TVIF_TEXT or TVIF_CHILDREN
    ti.item.pszText = AddressOf (a.Data)
    ti.item.cchTextMax = a.Length()-1

    Node.ControlId = SendMessage (w.hWnd, TVM_INSERTITEM, 0, AddressOf ( ref ti ))

end sub


function Node.hTreeView () as integer
    return = this.m_handle
end function

'function Node.Id () as integer
'    return = this.m_id
'end function

sub Node.Text ( byref m_Text as string )
    dim byref w as Widget
    dim t as TV_ITEM
    memset ( ref t, 0, sizeof(TV_ITEM) )
    set w = this.hTreeView
    dim a as AnsiString ( m_Text )
    t.hItem = this.ControlId
    t.mask = TVIF_TEXT 
    t.pszText = AddressOf (a.Data)
    t.cchTextMax = a.Length()-1
    SendMessage (w.hWnd, TVM_SETITEM, 0, AddressOf ( ref t ))

end sub

function Node.Text () as string
    dim byref w as Widget
    dim t as TV_ITEM
    memset ( ref t, 0, sizeof(TV_ITEM) )
    set w = this.hTreeView


    dim mem as pointer = malloc (1024)

    t.hItem = this.ControlId
    t.mask = TVIF_TEXT 
    t.pszText = AddressOf (mem)
    t.cchTextMax = 1024

    SendMessage (w.hWnd, TVM_GETITEM, 0, AddressOf ( ref t ))

    return = CharToStr ( mem )

    mfree ( mem )

end function


'TreeView Class

published class TreeView: implements Widget
      dim m_sel as pointer = null
private:


public:
      property SelectedItem as pointer
      public Items as Node ( this )

      declare sub ClearItems ()


      '  Node   
      sub TreeView ( byref Widget as Widget )

end class


'sub TreeView.Add ( byref Node as Node )
'end sub

sub TreeView.SelectedItem ( byref Sel as pointer )
    this.m_sel = Sel
end sub

function TreeView.SelectedItem () as pointer
    return = this.m_sel
end function


sub TreeView.TreeView ( byref Widget as Widget )
    this.ParentControl = Widget
    this.CreateControl ( "SysTreeView32", WS_CHILD or WS_TABSTOP or TVS_SHOWSELALWAYS or TVS_LINESATROOT or TVS_HASLINES or _
                                          WS_VISIBLE or TVS_HASBUTTONS or WS_EX_LEFT or WS_EX_LTRREADING or WS_EX_RIGHTSCROLLBAR or WS_EX_RIGHTSCROLLBAR or _
                                          TVS_DISABLEDRAGDROP or TVS_FULLROWSELECT, 10, 10, 190, 300, Widget.hWnd )

    this.BorderStyle = bsSIngle
    this.Caption = "TreeView"
    this.Items.m_handle = ref this
    this.Items.ControlId = 0
    this.Items.ChildClass = true
end sub

sub TreeView.ClearItems ()

dim i as integer, c as integer

    c = this.Items.GetControlCount
    if c > 0 then

       for i = 0 to c - 1

           dim byref Control as Control
           set Control = this.Items.GetControl (i)

           delete Control

       next


    end if

end sub

sub Node.Node ( byref Control as Control )
    this.ParentControl = Control

    if Control.IsImplement ("Node") then
       dim byref nd as Node
       set nd = ref Control
       nd.Add ( this )
    end if

    if Control.IsImplement ("TreeView") then
       dim byref tv as TreeView
       set tv = ref Control
       tv.Items.Add ( this )
    end if

end sub


sub InitLibrary

    RegisterClass ( "TreeView", subptrclass ( TreeView, TreeView ) )

end sub
