'*
'*  Widget Class
'*
'*  Copyright(c) by Metlashevskiy Egor
'*
'*   Widget  ,   
'*      Window ()
'*
'*     Widget     WIN API
'*    Widget       
'*    (Caption,Left,Top,Visible.....)   .
'*
'*
unit windows.gui.Widget

$document "../../../doc/Widget.htm"

import lang.Object
import lang.AnsiString
import windows.gui.Canvas
import windows.gui.Menu
import windows.gui.Edit
import windows.gui.CustomScrollBar
import windows.gui.ComboBox
import windows.gui.ToolTip
import windows.gui.TabControl
import windows.gui.TreeView

$include "commctrl.inc"

import console

'**
'*  
'*
private widget_nameinc as long = 0 '   
private widget_procaddress as pointer = 0 '    WNDPROC  


'**
'*   
'*
published enum WidgetShowStyles
	swHide = 0
	swNormal = 1
	swShowMinimized = 2
	swShowMaximized = 3
	swManximize = 3
	swShowNoActive = 4
	swShow = 5
	swMinimize = 6
	swShowMinNoActive = 7
	swShowNA = 8
	swRestore = 9
	swShowDefault = 10
        swShowModal = &H80
end enum

'**
'*   
'*
published enum WidgetBorderStyles
        bsNone = 0
        bsSoft = 1
        bsSingle = 2
end enum

'**
'*      Window ()
'*
private declare sub Widget_WndProc(byval hWnd as long, byval message as long, byval wParam as long, byval lParam as long) 

private widget_ToolTip as ToolTip 

'**
'* Widget      ,
'*        (Windows).
'* Widget  ,       Wnd,
'*        API  (Button, Static Text, ListBox, ComboBox, ...  .)
'*
published class Widget: implements Control ()

public:

      dim m_wnd as long = NULL
      dim m_showstyle as WidgetShowStyles 
      dim m_oldwndproc as pointer = 0
      dim m_mainmenu as pointer = null
      dim m_hint as string
public:

      dim Canvas as Canvas ( this )
      dim Font as Font ( this )
      dim Brush as Brush ( this )
     ' dim ToolTip as ToolTip ( this )

      ';dim byref VScroll as CustomScrollBar ()

      '     WIN API
      property hWnd as long 
      ' ,   
      property Parent as Widget
      '        hWnd
      property readonly ParentWnd as long
      '  
      property readonly ClientWidth as integer
      '  
      property readonly ClientHeight as integer

published:
      '  
      property Caption as string
      '  
      property ShowStyle as WidgetShowStyles
      ' 
      property BorderStyle as WidgetBorderStyles
      'true -  , false -  
      property Visible as boolean
      '      
      property Left as integer
      '      
      property Top as integer
      '  
      property Width as integer
      '  
      property Height as integer
      'true -     
      property VertScroll as boolean
      'true -     
      property HorzScroll as boolean
      '  
      property Hint as string
      '   
      property Enabled as boolean
public:
      '  MainMenu
      property MainMenu as pointer

published:
      '  Widget
      event OnDestroy ()
      ' ,     .
      event OnClose ()
      ' ,       
      event OnPaint ()
      '   
      event OnActive ()
      '    
      event OnDeactive ()
      ' 
      event OnShow ()
      '  
      event OnCreate ()
      '  
      event OnClick ()
      '   
      event OnDblClick ()
      '  
      event OnResize ()
      ' 
      event OnKeyPress ( byval KeyAscii as integer )
      '     ,
      'Button -  , X,Y -  
      event OnMouseMove ( byval Button as long, _
                          byval Shift as long, byval X as long, byval Y as long )
      '  ,
      'Button -  , X,Y -  
      event OnMouseDown ( byval Button as long, _
                          byval Shift as long, byval X as long, byval Y as long )
      '  ,
      'Button -  , X,Y -  
      event OnMouseUp   ( byval Button as long, _
                          byval Shift as long, byval X as long, byval Y as long )


public:

      '** 
      '*   ,   
      '*
      declare sub CreateWindow ( byval dwStyle as long, _
                                 byval X as long, byval Y as long, _
                                 byval Width as long, byval Height as long, _
                                 byval WndParent as long, byval hMenu as long )

      '**
      '*   (Button, Edit, Static ... )
      '*
      declare sub CreateControl ( byval wndClass as string, byval dwStyle as long, _
                                  byval X as long, byval Y as long, _
                                  byval Width as long, byval Height as long, _
                                  byval WndParent as long )


      '  
      declare sub Show ()
      '  
      declare sub ShowModal ()
      '  
      declare sub Close ()
      '  
      declare sub Refresh ()
      '  
      declare sub Move ( byval Left as long, byval Top as long, byval Width as long, byval Height as long )
      '  
      declare sub Active ()


      '**
      '*      
      '*

      '  
      declare sub SetWndStyle ( byval Style as long )
      '  
      declare function GetWndStyle () as long
      '   
      declare sub SetWndExStyle ( byval ExStyle as long )
      '   
      declare function GetWndExStyle () as long
      '  
      declare sub AddWndStyle ( byval Style as long )
      '  
      declare sub RemoveWndStyle ( byval Style as long )
      '   
      declare sub AddWndExStyle ( byval ExStyle as long )
      '   
      declare sub RemoveWndExStyle ( byval ExStyle as long )
      ' true,     
      declare function IsWndStyle ( byval Style as long ) as boolean
      ' true,      
      declare function IsWndExStyle ( byval ExStyle as long ) as boolean




      virtual sub WndProc ( byval hWnd as long, byval Message as long, byval WParam as long, byval LParam as long, byref Ret as boolean )
      end sub

      '**
      '*    
      '*
      sub GetClientRect ( byref Rect as RECT )
          dim p as POINTAPI
          dim parent as pointer = this.ParentWnd

          GetWindowRect ( this.m_wnd, rect )
          if parent <> null then
            p.x = rect.left
            p.y = rect.top
            ScreenToClient ( parent, p )
            rect.left = p.x
            rect.top = p.y
            p.x = rect.right
            p.y = rect.bottom
            ScreenToClient ( parent, p )
            rect.right = p.x
            rect.bottom = p.y
          end if

      end sub

      '**
      '*    
      '*
      sub SetClientRect ( byref Rect as RECT )
          SetWindowPos this.m_wnd, 0, rect.left, rect.top, rect.right-rect.left, rect.bottom-rect.top, SWP_NOACTIVATE
      end sub


      sub Widget ()
      sub ~Widget ()

      virtual sub Free ()

        if this.hWnd <> null then

           DestroyWindow ( this.hWnd)

        end if


      end sub


end class

'*
'* -   
'*
private sub Widget_OnDestroy ( byref Widget as Widget ): end sub
private sub Widget_OnClose ( byref Widget as Widget ): end sub
private sub Widget_OnPaint ( byref Widget as Widget ): end sub
private sub Widget_OnResize ( byref Widget as Widget ): end sub
private sub Widget_OnActive ( byref Widget as Widget ): end sub
private sub Widget_OnDeactive ( byref Widget as Widget ): end sub
private sub Widget_OnShow ( byref Widget as Widget ): end sub
private sub Widget_OnCreate ( byref Widget as Widget ): end sub
private sub Widget_OnClick ( byref Widget as Widget ): end sub
private sub Widget_OnDblClick ( byref Widget as Widget ): end sub
private sub Widget_OnMouseMove ( byref Sender as Widget, byval Button as long, byval Shift as long, byval X as long, byval Y as long ): end sub
private sub Widget_OnMouseDown ( byref Sender as Widget, byval Button as long, byval Shift as long, byval X as long, byval Y as long ): end sub
private sub Widget_OnMouseUp ( byref Sender as Widget, byval Button as long, byval Shift as long, byval X as long, byval Y as long ): end sub
private sub Widget_OnKeyPress ( byref Widget as Widget, byval KeyAscii as integer ): end sub

private event Widget_Font_OnChange ( byref Font as Font )
dim parent as long = Font.GetParentClass()
if parent <> null then
   dim byref w as Widget
   set w = parent
   SendMessage ( w.m_wnd, WM_SETFONT, Font.hFont, 0)
end if
end sub

private event Widget_Brush_OnChange ( byref Brush as Brush )
dim parent as long = Brush.GetParentClass()
'msgbox "BONCHANGE" + str(parent)
if parent <> null then
   dim byref w as Widget
   set w = parent
   SetClassLong w.m_wnd, GCL_HBRBACKGROUND, Brush.hBrush
   w.Refresh
   'w.Caption = "34"
   'msgbox "b change"
   'SendMessage ( w.m_wnd, WM_SETFONT, Font.hFont, 0)
end if
end sub

sub Widget.Hint ( byref Hint as string )
    this.m_hint = Hint
    widget_ToolTip.AddTool (Hint, this)
end sub

function Widget.Hint () as string
    return = this.m_hint
end function


sub Widget.MainMenu ( byref Menu as pointer )
    this.m_mainmenu = Menu
end sub

function Widget.MainMenu () as pointer
    return = this.m_mainmenu
end function


sub Widget.BorderStyle ( byref bStyle as WidgetBorderStyles )
    if bStyle = bsNone then
       this.RemoveWndExStyle ( WS_EX_CLIENTEDGE )
       this.RemoveWndExStyle ( WS_EX_STATICEDGE )
    end if
    if bStyle = bsSoft then
       this.RemoveWndExStyle ( WS_EX_CLIENTEDGE )
       this.AddWndExStyle ( WS_EX_STATICEDGE )
    end if
    if bStyle = bsSingle then
       this.AddWndExStyle ( WS_EX_CLIENTEDGE )
       this.RemoveWndExStyle ( WS_EX_STATICEDGE )
    end if
end sub

function Widget.BorderStyle () as WidgetBorderStyles
dim style as long = this.GetWndExStyle ()
dim wc as boolean = ( (style and WS_EX_CLIENTEDGE) mod (WS_EX_CLIENTEDGE-1) )
dim ws as boolean = ( (style and WS_EX_STATICEDGE) mod (WS_EX_STATICEDGE-1) )
    if (wc=false) and (ws=true) then
       return = bsSoft
    end if 
    if (wc=true) and (ws=false) then
       return = bsSingle
    end if 
    if (wc=false) and (ws=false) then
       return = bsNone
    end if 
end function

sub Widget.Active ()
    SetActiveWindow ( this.m_wnd )
end sub

'**
'*      
'*
sub Widget.SetWndStyle ( byval Style as long )
  SetWindowLong ( this.m_wnd, GWL_STYLE, Style )
end sub

function Widget.GetWndStyle () as long
  return = GetWindowLong ( this.m_wnd, GWL_STYLE )
end function

sub Widget.SetWndExStyle ( byval ExStyle as long )
  SetWindowLong ( this.m_wnd, GWL_EXSTYLE, ExStyle )
end sub

function Widget.GetWndExStyle () as long
  return = GetWindowLong ( this.m_wnd, GWL_EXSTYLE )
end function

sub Widget.AddWndStyle ( byval Style as long )
  dim st as long = GetWindowLong ( this.m_wnd, GWL_STYLE )
  st = st or Style
  SetWindowLong ( this.m_wnd, GWL_STYLE, st)
end sub

sub Widget.AddWndExStyle ( byval Style as long )
  dim st as long = GetWindowLong ( this.m_wnd, GWL_EXSTYLE )
  st = st  or Style
  SetWindowLong ( this.m_wnd, GWL_EXSTYLE, st)
end sub

sub Widget.RemoveWndStyle ( byval Style as long )
  dim st as long = GetWindowLong ( this.m_wnd, GWL_STYLE )
  st = st and (not Style)
  SetWindowLong ( this.m_wnd, GWL_STYLE, st)
end sub

sub Widget.RemoveWndExStyle ( byval Style as long )
  dim st as long = GetWindowLong ( this.m_wnd, GWL_EXSTYLE )
  st = st and (not Style)
  SetWindowLong ( this.m_wnd, GWL_EXSTYLE, st)
end sub

function Widget.IsWndStyle ( byval Style as long ) as boolean
  dim st as long = GetWindowLong ( this.m_wnd, GWL_STYLE )
  return = ( (st and style) mod (style-1) )
end function

function Widget.IsWndExStyle ( byval ExStyle as long ) as boolean
  dim st as long = GetWindowLong ( this.m_wnd, GWL_EXSTYLE )
  return = ( (st and exstyle) mod (exstyle-1) )
end function


function Widget.ClientWidth () as integer
dim rect as RECT
  GetClientRect ( this.m_wnd, rect )
  return = rect.Right
end function

function Widget.ClientHeight () as integer
dim rect as RECT
  GetClientRect ( this.m_wnd, rect )
  return = rect.Bottom
end function

sub Widget.HorzScroll ( byref m_HScroll as boolean )
dim style as long
  style = this.GetWndStyle()
  if m_HScroll = true then
     style = style or WS_HSCROLL
  else
     style = style and (not WS_HSCROLL)
  end if
  this.SetWndStyle (style)
end sub

function Widget.HorzScroll () as boolean
dim style as dword
  style = this.GetWndStyle()
  return = ( ( style and WS_HSCROLL ) mod (WS_HSCROLL-1) )
end function

sub Widget.VertScroll ( byref m_HScroll as boolean )
dim style as long
  style = this.GetWndStyle()
  if m_HScroll = true then
     style = style or WS_VSCROLL
  else
     style = style and (not WS_VSCROLL)
  end if
  this.SetWndStyle (style)
end sub

function Widget.VertScroll () as boolean
dim style as dword
  style = this.GetWndStyle()
  return = ( ( style and WS_VSCROLL ) mod (WS_VSCROLL-1) )
end function

sub Widget.Enabled ( byref m_Value as boolean )
    EnableWindow(this.hWnd, m_Value)
end sub

function Widget.Enabled () as boolean
    return = IsWindowEnabled(this.hwnd)
end function

'**
'*  Left,   
'*
sub Widget.Left ( byref Value as integer )
dim rect as RECT
dim w as long
    this.GetClientRect (rect)
    w = rect.right - rect.left
    rect.Left = Value
    rect.Right = rect.Left + w
    this.SetClientRect (rect)
end sub

function Widget.Left () as integer
dim rect as  RECT
    this.GetClientRect (rect)
    return = rect.Left
end function

'**
'*  Top,   
'*
sub Widget.Top ( byref Value as integer )
dim rect as RECT
dim h as long
    this.GetClientRect (rect)
    h = rect.bottom - rect.top
    rect.Top = Value
    rect.Bottom = rect.Top + h
    this.SetClientRect (rect)
end sub

function Widget.Top () as integer
dim rect as  RECT
    this.GetClientRect (rect)
    return = rect.Top
end function

'**
'*  Width,  
'*
sub Widget.Width ( byref Value as integer )
dim rect as RECT
dim h as long
    this.GetClientRect (rect)
    rect.Right = rect.Left + Value
    this.SetClientRect (rect)
end sub

function Widget.Width () as integer
dim rect as  RECT
    this.GetClientRect (rect)
    return = rect.Right - rect.Left
end function

'**
'*  Height,  
'*
sub Widget.Height ( byref Value as integer )
dim rect as RECT
dim h as long
    this.GetClientRect (rect)
    rect.Bottom = rect.Top + Value
    this.SetClientRect (rect)
end sub

function Widget.Height () as integer
dim rect as  RECT
    this.GetClientRect (rect)
    return = rect.Bottom - rect.Top
end function

sub Widget.Move ( byval Left as long, byval Top as long, byval Width as long, byval Height as long )
dim rect as  RECT
    rect.Left = Left
    rect.Top = Top
    rect.Right = Left + Width
    rect.Bottom = Top + Height
    this.SetClientRect (rect)
end sub



function Widget.ParentWnd () as long
    return = GetParent ( this.m_wnd )
end function

sub Widget.Parent ( byref Widget as Widget )
  'msgbox "A="+str(Widget.m_wnd)
  SetWindowLong ( this.m_wnd, GWL_HWNDPARENT, Widget.m_wnd )
  'UpDateWindow ( this.m_wnd )
  'UpDateWindow ( Widget.m_wnd )
  SetParent ( this.m_wnd, Widget.m_wnd )
  SendMessage ( this.m_wnd, WM_CHANGEUISTATE, UIS_INITIALIZE, 0)

  dim r as RECT
  GetWindowRect ( this.m_wnd, r)
  RedrawWindow ( this.m_wnd, r, 0, 0)


  this.ParentControl = Widget
  this.Refresh()

  'ShowWIndow (this.m_wnd,0)
  'ShowWIndow (this.m_wnd,1)
  'this.Refresh()
  'Widget.Refresh()

end sub

function Widget.Parent () as Widget
end function

sub Widget.Visible ( byref Visible as boolean )
    if Visible = true then
       ShowWindow this.m_wnd, this.m_showstyle
    else
       ShowWindow this.m_wnd, SW_HIDE
    end if 
end sub

function Widget.Visible () as boolean
  return = false
  dim wdStyle as long
  dwStyle = GetWindowLong ( this.m_wnd, GWL_STYLE)
  if (dwStyle and WS_VISIBLE) = WS_VISIBLE then
    return =  true
  end if
  'return = IsWindowVisible ( this.m_wnd )
end function

sub Widget.Refresh ()
    UpdateWindow ( this.m_wnd )
    DrawMenuBar ( this.m_wnd )
    SendMessage this.m_wnd, WM_SIZE, 0, 0
    SendMessage this.m_wnd, WM_PAINT, 0, 0
    RedrawWindow ( this.m_wnd, 0, 0, RDW_INVALIDATE)

    'dim w as integer = this.Height
    'this.Height = w
end sub

sub Widget.Close ()
    CloseWindow ( this.m_wnd )
end sub

sub Widget.Show ()
   ShowWindow this.m_wnd, this.m_showstyle
end sub

sub Widget.ShowModal ()
   this.AddWndExStyle WS_EX_DLGMODALFRAME  
   ShowWindow this.m_wnd, this.m_showstyle
end sub

'**
'* Create window 
'*
sub Widget.CreateWindow ( byval dwStyle as long, byval X as long, byval Y as long, _
                          byval Width as long, byval Height as long, _
                          byval WndParent as long, byval hMenu as long )

dim wndcls as WNDCLASS
dim cname as string
    widget_nameinc = widget_nameinc + 0
    cname = "WidgetWindow" + str( widget_nameinc )

    wndcls.style = CS_DBLCLKS or CS_OWNDC or CS_CLASSDC or CS_VREDRAW or CS_HREDRAW
    'wndcls.style = 0
    wndcls.lpfnwndproc = widget_procaddress
    wndcls.cbClsextra = 0
    wndcls.cbWndExtra2 = 0
    wndcls.hInstance =  GetModuleHandle(0)
    wndcls.hIcon = 0
    wndcls.hCursor = LoadCursor(0, IDC_ARROW)
    wndcls.hbrBackground = CreateSolidBrush(GetSysColor(COLOR_BTNFACE))

    wndcls.lpszMenuName = 0
    wndcls.lpszClassName = malloc (255)
    strcpy (wndcls.lpszClassName, cname)
    wndcls.lpszClassName = AddressOf(wndcls.lpszClassName)
    RegisterClass (wndcls)
    dim hWnd as long
    hWnd = CreateWindowEx(0, cname, "WidgetWindow", dwStyle, _
                          X, Y, Width, Height, WndParent, hMenu, GetModuleHandle(0), 0)
    this.m_wnd = hWnd
    SetProp ( hWnd, "WidgetClassPtr", ref this )
    this.Canvas.hDC = GetDC ( hWnd )
    this.Brush.CreateSolidBrush (GetSysColor(COLOR_BTNFACE))
    widget_nameinc = widget_nameinc + 1


end sub

'**
'* CreateControl
'*
sub Widget.CreateControl ( byval wndClass as string, byval dwStyle as long, byval X as long, byval Y as long, _
                           byval Width as long, byval Height as long, _
                           byval WndParent as long )


    dim hWnd as long
    hWnd = CreateWindowEx(0, wndClass, "WidgetControl", dwStyle, X, Y, Width, Height, WndParent, this.ControlId, GetModuleHandle(0), 0)
    if hWnd <> null then
       this.m_wnd = hWnd
       SetProp ( hWnd, "WidgetClassPtr", ref this )
       this.m_oldwndproc = SetWindowLong(hWnd, GWL_WNDPROC, widget_procaddress)
       this.Canvas.hDC = GetDC ( hWnd )
       Widget_Font_OnChange (this.Font)
       this.Brush.CreateSolidBrush (GetSysColor(COLOR_BTNFACE))
    end if

    this.AddWndExStyle (WS_EX_NOPARENTNOTIFY)

    this.OnCreate ()

end sub




'**
'* ShowStyle
'*
sub Widget.ShowStyle ( byref Style as WidgetShowStyles )
    this.m_showstyle = Style
end sub

function Widget.ShowStyle () as WidgetShowStyles
    return = this.m_showstyle
end function

'**
'* Caption
'*
sub Widget.Caption ( byref Caption as string )
    dim s as AnsiString (Caption)
    SetWindowText ( this.m_wnd, AddressOf (s.Data))
end sub

function Widget.Caption () as string
    dim ch(1024) as byte
    GetWindowText ( this.m_wnd, AddressOf(ref ch), 1024 )
    return = CharToStr (ref ch)
end function


sub Widget.hWnd ( byref Wnd as long )
    this.m_wnd = wnd
end sub

function Widget.hWnd () as long
    return = this.m_wnd
end function

sub Widget.Widget ()
    this.m_showstyle = swNormal
    this.OnDestroy = subptr ( Widget_OnDestroy )
    this.OnClose = subptr ( Widget_OnClose )
    this.OnPaint = subptr ( Widget_OnPaint )
    this.OnResize = subptr ( Widget_OnResize )
    this.OnActive = subptr ( Widget_OnActive )
    this.OnDeactive = subptr ( Widget_OnDeactive )
    this.OnShow = subptr ( Widget_OnShow )
    this.OnCreate = subptr ( Widget_OnCreate )
    this.OnClick = subptr ( Widget_OnClick )
    this.OnDblClick = subptr ( Widget_OnDblClick )
    this.OnMouseDown = subptr ( Widget_OnMouseDown )
    this.OnKeyPress = subptr ( Widget_OnKeyPress )

    this.Font.OnChange = subptr ( Widget_Font_OnChange )
    this.Brush.OnChange = subptr ( Widget_Brush_OnChange )

    this.Font.Name = "Font"
    this.Brush.Name = "Brush"
    this.Canvas.Name = "Canvas"

    this.Font.ChildClass = true
    this.Brush.ChildClass = true
    this.Canvas.ChildClass = true

    this.ShowStyle = swNormal
end sub

'**
'* WNDPROC   
'*     .
'*
'* (     )
'*        WNDPROC,
'*    OnClick, OnMouseMove......
'*

dim k as integer = 0


private sub Widget_WndProc(byval hWnd as long, byval message as long, byval wParam as dword, byval lParam as long) 
'if LoaderStatus = 0 then


dim wcPtr as pointer = GetProp ( hWnd, "WidgetClassPtr" )
dim byref Widget as Widget
dim ret as boolean = false
set Widget = wcptr
    dim go as boolean = true


    if wcPtr <> null then
       Widget.WndProc ( hwnd, message, wparam, lparam, ret )
    end if


    select case message
        case WM_NOTIFY:

             dim ID2 as long = LOWORD (wParam)

             if ID2 <> 0 then
                dim byref ctrl2 as Widget
                set ctrl2 = Widget.GetControlById (ID2)
                if (ref ctrl2) <> null then
                  dim byref ndr as NMHDR
                  set ndr = VirtualOf(lparam)
                  dim eq as short 

                  eq = TCN_SELCHANGE
                  if ndr.code = eq  then
                     dim byref Tabc as TabControl
                     set Tabc = ref ctrl2
                     Tabc.OnChange ()
                  end if

                  eq = TCN_SELCHANGING
                  if ndr.code = eq  then
                     dim byref Tabc2 as TabControl
                     set Tabc2 = ref ctrl2
                     'Tabc.OnChanging ()
                  end if

                  eq =  TVN_SELCHANGING
                  if ndr.code = eq then
                     dim byref nm as NM_TREEVIEW
                     set nm = ref ndr

                     dim byref Tree as TreeView
                     set Tree = ref ctrl2
                     Tree.SelectedItem = Tree.Items.GetControlById ( nm.itemNew.hItem ) 
                  end if

                end if


             end if

        case WM_COMMAND:

             if Widget.m_mainmenu <> null then

               dim wID as dword = LOWORD (wParam)
               dim byref mm as MainMenu
               dim byref mi as MenuItem
               set mm = Widget.MainMenu
               set mi = mm.GetMenuById ( wID )
               if ( set mi ) <> null then
                     mi.OnClick ()
               end if
             end if

             dim ID as long = LOWORD (wParam)

             if ID <> 0 then

                dim byref ctrl as Control
                set ctrl = Widget.GetControlById (ID)

                if (set ctrl) <> null then
                  if HIWORD (wParam) = EN_CHANGE then
                     dim byref Edit as Edit
                     set Edit = ref ctrl
                     Edit.OnChange ()
                  end if

                  if HIWORD (wParam) = CBN_SELCHANGE then
                     if lcase(ctrl.ClassName) = "combobox" then
                       dim byref Combo as ComboBox
                       set Combo = ref ctrl
                       Combo.OnChange ()
                     end if
                  end if

                end if


             end if

        case WM_LBUTTONUP:
            if wcPtr <> null then
               Widget.OnClick ()
            end if
        case WM_RBUTTONUP:
            if wcPtr <> null then
               Widget.OnClick ()
            end if
        case WM_MBUTTONUP:
            if wcPtr <> null then
               Widget.OnClick ()
            end if
        case WM_LBUTTONDBLCLK:
            if wcPtr <> null then
               Widget.OnDblClick ()
            end if
        case WM_RBUTTONDBLCLK:
            if wcPtr <> null then
               Widget.OnDblClick ()
            end if
        case WM_MBUTTONDBLCLK:
            if wcPtr <> null then
               Widget.OnDblClick ()
            end if
        case WM_ACTIVATE:
            if wcPtr <> null then
               if (wParam = WA_ACTIVE) or (wParam = WA_CLICKACTIVE) then
                  Widget.OnActive ()
               end if
               if (wParam = WA_INACTIVE) then
                  Widget.OnDeactive ()
               end if
            end if
        case WM_SHOWWINDOW:
            if wcPtr <> null then
               Widget.hDC = GetDC (hWnd)
               Widget.OnShow ()
            end if
        case WM_CREATE:
            if wcPtr <> null then
               Widget.OnCreate ()
            end if
        case WM_PAINT:
            if wcPtr <> null then

               'dim ps as PAINTSTRUCT
               'BeginPaint (Widget.hWnd, ps)
               Widget.OnPaint ()
               'EndPaint (Widget.hWnd, ps)

            end if
        case WM_SIZE:
            if wcPtr <> null then
               Widget.OnResize ()
            end if

        case WM_CLOSE:
            if wcPtr <> null then
               Widget.OnClose ()
            end if
        case WM_DESTROY:
            if wcPtr <> null then
               Widget.OnDestroy ()
            end if
        case WM_KEYDOWN:
            if wcPtr <> null then
               Widget.OnKeyPress (wparam)
            end if
        'case WM_VSCROLL:
           'if wcPtr <> null then
           'end if
    end select

    if wcPtr <> null then
    if (message = WM_LBUTTONDOWN) or (message = WM_RBUTTONDOWN) or (message = WM_MBUTTONDOWN) then
       dim Btn as long = MK_LBUTTON
       dim pa as pointapi
       dim r as rect
       GetCursorPos (pa)
       GetWindowRect (Widget.hWnd, r)

       Widget.OnMouseDown (wParam and &H3, wParam and MK_SHIFT, pa.x - r.left,  pa.y-r.top)
    end if

    end if




    if ret = false then
    if wcPtr <> 0 then
    if Widget.m_oldwndproc <> 0 then
       go = false
       returnEAX CallWindowProc(Widget.m_oldwndproc, hWnd, message, wParam, lParam)
    end if
    end if

    if go = true then
       ReturnEAX DefWindowProc(hWnd, message, wParam, lParam)
    end if
    end if

    'print ret, " ", go, " ", Widget.m_oldwndproc, "\n"

'end if
End sub

sub Widget.~Widget ()

end sub

'**
'*   Widget,  .
'*
sub InitLibrary
    widget_procaddress = procaddress ( Widget_WndProc )
    InitCommonControls ()
end sub

'**
'* 
'*
sub ReleaseLibrary

end sub
