'*                                                                              
'*  MESSAGEBOX.BAS - Force Basic Module                                         
'*                                                                              
'*  Copyright(c) 2005 by Metlashevskiy Egor. All right reserved                 
'*                                                                            
'*
unit windows.MessageBox
 
$ifndef _MESSAGEBOX_BAS
$define _MESSAGEBOX_BAS

public enum CONST_MESSAGEBOXSTYLE
	MB_DEFBUTTON1 = &H0              	
	MB_DEFBUTTON2 = &H100                   
	MB_DEFBUTTON3 = &H200
	MB_ICONASTERISK = &H40
	MB_ICONEXCLAMATION = &H30
	MB_ICONHAND = &H10
	MB_ICONINFORMATION = MB_ICONASTERISK
	MB_ICONQUESTION = &H20
	MB_ICONSTOP = MB_ICONHAND
	MB_OK = &H0
	MB_OKCANCEL = &H1
	MB_YESNO = &H4
	MB_YESNOCANCEL = &H3
	MB_ABORTRETRYIGNORE = &H2
	MB_RETRYCANCEL = &H5
end enum

public declare function MessageBox lib "user32" alias "MessageBoxA" (byval hwnd AS dword, byref lpText as string, byref lpCaption as string, byval wType as dword) as dword

public sub msgbox (msg as string, style as dword)
       messagebox (0, msg, Runable.Title, style)
end sub

public sub msgbox (msg as string)
       messagebox (0, msg, Runable.Title, 0)
end sub

public sub msgbox (msg as string, title as string, style as dword)
	messagebox (0, msg, title, style)
end sub

public sub msgbox (msg as string, title as string)
	messagebox (0, msg, title, 0)
end sub


sub RaiseError
    msgbox Runable.ErrDesc, "Run-Time Error"
end sub

sub InitLibrary
    Runable.OnError = subptr (RaiseError)
end sub

sub ReleaseLibrary
end sub

$endif