'*
'* Event(s) Store Classes for ForceBasic Form Builder
'*
unit User.FormBuilder.EventStore


import windows.gui.Control

class EventData: implements Object
      dim EventName as string
      dim Text as string
      dim EventProcName as string
end class


class ObjectEventStore: implements Collection

      dim classptr as pointer = null

      function GetFromName ( byval Name as string ) as pointer
          return = null
          dim i as integer
          c = this.count
          if c > 0 then
             for i = 0 to c-1
                 dim byref oes as EventData
                 set oes = this.Item (i)
                 if ref oes <> null then
                    if lcase(oes.EventName) = lcase(Name) then
                       return = ref oes
                       'exit for
                    end if
                 end if
             next
          end if
      end function

      sub StoreEvent ( byval EventName as string, _
                       byval Text as string, _ 
                       byval EventProcName as string )


          dim byref ed as EventData
          set ed = this.GetFromName ( EventName )

          if ref ed = null then
             set ed = new EventData()
             this.Add ( ed )
          end if

          if ref ed <> null then

             ed.EventName = EventName
             ed.Text = Text
             ed.EventProcName = EventProcName

          end if

      end sub

      function GetEvent ( byval EventName as string ) as pointer
          return = null
          dim byref ed as EventData
          set ed = this.GetFromName ( EventName )
          if ref ed <> null then
             return = ref ed
          end if
      end function


end class


class EventsStore: implements Collection



      function IndexOfControl ( byref Control as Control ) as integer
        
          return = -1
          dim i as integer, c as integer
          dim byref oes as ObjectEventStore
          c = this.Count
          if c > 0 then
             for  i = 0 to c - 1
                  set oes = this.Item ( i )
                  if oes.classptr = ref Control then
                     return = i 
                     'exit for
                  end if
             next
          end if

      end function

      sub StoreEvent ( byref Control as Control, _
                       byval EventName as string, _
                       byval Text as string, _ 
                       byval EventProcName as string )

          dim cind as integer

          cind = this.IndexOfControl(Control)
          dim byref oes as ObjectEventStore

          if cind = -1 then 
             set oes = new ObjectEventStore()
             oes.classptr = ref Control
             this.Add ( oes )
             'msgbox str(this.COunt)
          else
             set oes = this.Item (cind)
          end if


          if ref oes <> null then
             oes.StoreEvent ( EventName, Text, EventProcName )
             'msgbox "se"
          end if

      end sub

      function GetEvent ( byref Control as Control, byval EventName as string ) as pointer
          return = null
          dim cind as integer
          cind = this.IndexOfControl( Control )
          dim byref oes as ObjectEventStore
          set oes = null
          'msgbox str (cind)

          if cind = -1 then 
          else
             set oes = this.Item (cind)
             if ref oes <> null then
                'msgbox EventName
                return = oes.GetEvent ( EventName )
             end if
          end if
      end function

      declare function StoreEventData ( byref Ctrl as Control ) as string
      sub EventsStore()

end class

sub EventsStore.EventsStore ()

end sub

function EventsStore.StoreEventData ( byref Ctrl as Control ) as string

 dim i as integer, c as integer
 dim i2 as integer, c2 as integer
 dim ret as string


 ret = ret + "\n"
 ret = ret + "'Event data\n"

 c = this.Count
 if c > 0 then
    for i = 0 to c-1
        dim byref oes as ObjectEventStore
        set oes = this.Item (i)

        c2 = oes.Count
        if c2 > 0 then

           for i2 = 0 to c2 -1 
               dim byref ed as EventData
               set ed = oes.Item(i2)

               if ed.EventProcName = "_prop_" then
               else

               ret = ret + "CREATE EVENT " + ed.EventProcName + "\n"

               dim byref Ct as Control
               set Ct = oes.classptr
               ret = ret + Ct.Name + "\n"
               ret = ret + ed.EventName + "\n"
               ret = ret + rtrim(ed.Text) + "\n"
               ret = ret + "END CREATE\n"

               end if

           next

        end if

    next

 end if


 return = ret

end function


dim EventsStore as EventsStore()

sub LoadEvents ( byref cl as ClassLoader, byref ctrl as Control, byval f as file)
dim mev as boolean = false
dim ctn as string
dim en as string
dim ren as string
dim txt as string

   if f <> null then
    do
      if feof (f) then exit do
      dim text as string
      text = fgets (f, 1024)

      if mid(text,0,10) = "END CREATE" then
         mev = false
         'print ren, " ", ctn, " ", en
         'print txt

         dim byref rctrl as Control
         set rctrl = ctrl.GetControlByName (ctn)

         if lcase(ctrl.Name) = lcase(ctn) then
            set rctrl = ref ctrl
         end if

         if ref rctrl <> null then


            EventsStore.StoreEvent ( rctrl, en, txt, ren)

         end if

         'print ref rctrl

      end if

      if mev = true then
         txt = txt + rtrim (text) + chr(13) + chr(10)  
'+ chr(13) + chr(10)
      end if


      if mid(text,0,12) = "CREATE EVENT" then
         ren = trim(mid(text,12))
         ctn$ = trim(fgets (f, 1024))
         en$ = trim(fgets (f, 1024))
         mev = true
         txt = ""
      end if


    loop
   end if
end sub


sub InitLibrary
end sub

sub ReleaseLibrary
end sub

