'*
'* MenuForm
'*
unit User.FormBuilder.MenuForm

import windows.gui.*
import User.FormBuilder.DynCtrl
import User.FormBuilder.DesignControl
import User.FormBuilder.EditForm
import User.FormBuilder.Connector
import User.FormBuilder.EventStore




declare sub MenuForm_OnDestroy ( byref Form as Form )
declare sub MenuForm_OnPaint ( byref Form as Form )
declare sub MenuForm_OnResize ( byref Form as Form )
declare sub MenuForm_Save ( byref Menu as MenuItem )
declare sub MenuForm_Load ( byref Menu as MenuItem )
declare sub MenuForm_New ( byref Menu as MenuItem )
declare sub MenuForm_CodeIt ( byref Menu as MenuItem )
declare sub mnuRun_Click ( byref Menu as MenuItem )
declare sub mnuViewCode_Click ( byref Menu as MenuItem )
declare sub mnuMH_Click ( byref Menu as MenuItem )
declare sub mnuHelp_Click ( byref Menu as MenuItem )
declare sub mnuCH_Click ( byref Menu as MenuItem )


class MenuForm: implements Form

      dim OpenSave as OpenSaveDialog ( this )

      dim Menu as MainMenu ( this )
      dim mnuFile as MenuItem ()
      dim mnuFileNew as MenuItem ()
      dim mnuFileSave as MenuItem ()
      dim mnuFileLoad as MenuItem ()
      dim mnuSep1 as MenuItem ()
      dim mnuInsert as MenuItem ()
      dim Status as StatusBar ( this )
      dim mnuForm as MenuItem ()
      dim mnuFormCodeIt as MenuItem ()
      dim mnuRun as MenuItem ()
      dim mnuViewCode as MenuItem ()
      dim mnuClass as MenuItem ()
      dim mnuModuleHeader as MenuItem ()
      dim mnuClassHeader as MenuItem ()
      dim mnuHelp as MenuItem ()
      dim mnuHelp1 as MenuItem ()



      sub MenuForm ()
      declare sub MakeInsertMenu ()


end class

class EventBuilder: implements ControlEventBuilder

      virtual sub StoreCurrentProperty ( byref ret as boolean, byref ctrl as Object, byref pi as PropertyInfo )

        'print pi.Name
        'ret=false
        dim go as boolean = true

        dim byref ct as Control
        set ct = ref ctrl

        if ct.IsImplement ("Widget") then
        if (pi.Name = "Left") or _
           (pi.Name = "Top") or _
           (pi.Name = "Width") or _
           (pi.Name = "Height") or _
           (pi.Name = "Caption") or _
           (pi.Name = "Name") or _
           (pi.Name = "Visible") then

           go = false


        end if
        end if


        if go = true then

        dim byref ed as EventData
        set ed = EventsStore.GetEvent ( ctrl, pi.Name ) 

        'print ref ed
           if ref ed = null then ret = false

        end if

      end sub


      virtual sub GetEventDeclares ( byref ret as string, byref ctrl as Object, byval cmd as integer )

        ret = ret + "\n"


        dim i as integer, c as integer
        c = EventsStore.count
        if c > 0 then
           for i = 0 to c-1
               dim byref oes as ObjectEventStore
               set oes = EventsStore.item ( i )
               if ref oes <> null then

                  dim i2 as integer, c2 as integer
                  c2 = oes.Count
                  if c2>0 then

                       for i2 = 0 to c2-1

                           dim byref ed as EventData
                           set ed = oes.item (i2)
                       'msgbox ed.EventName

                       if ed.EventProcName = "_prop_" then
                       else

                       if ed.EventName = "_ModuleClassCode_" then
                       else
                       if ed.EventName = "_ModuleHeaderCode_" then
                       else
                           ind = instr (0, ed.Text, chr(13), 0, false)
                           if ind = -1 then ind = len(ed.Text)

                           if cmd = 0 then
                           ret = ret + "declare " + trim(mid(ed.Text, 0, ind)) + "\n"
                           end if


                           if cmd = 1 then
                              dim r as string = "      this."
                              if ref ctrl <> oes.classptr then
                                 dim byref nc as Control
                                 set nc = oes.classptr

                                 r = r + nc.Name + "."
                              end if
                              r = r + ed.EventName + " = subptr ( " + ed.EventProcName + " ) \n"
                              ret = ret + r
                           end if
                           if cmd = 2 then
                              ret = ret + "\n" + StrReplace (ed.Text, chr(13) + chr(10), chr(10)) + "\n"
                              'ret = ret + "\n" + ed.Text + "\n"
                           end if
                       end if
                       end if
                       end if 
                       next

                  end if

               end if

           next

           if cmd = 0 then

              dim byref ed2 as EventData
              dim byref cct as Control
              set cct = ref ctrl
              set ed2 = EventsStore.GetEvent (cct, "_ModuleHeaderCode_")
              if ref ed2 <> null then
                 ret = ret + "\n" + StrReplace (ed2.Text, chr(13) + chr(10), chr(10)) + "\n"
              end if 


           end if
           if cmd = 3 then

              dim byref ed4 as EventData
              dim byref cct4 as Control
              set cct4 = ref ctrl
              set ed4 = EventsStore.GetEvent (cct4, "_ModuleClassCode_")
              if ref ed4 <> null then
                 ret = ret + "\n" + StrReplace (ed4.Text, chr(13) + chr(10), chr(10)) + "\n"
              end if 


           end if


        end if

        ret = ret + "\n"

      end sub


end class

dim EventBuilder as EventBuilder

sub Ins_Click ( byref MenuItem as MenuItem )
dim byref Edf as Widget
set Edf = EditedForm

   dim newControl as DesignControl
   newControl.CreateControl (MenuItem.Caption, Edf)
   'dim byref btn as RichEdit
   'set btn = new RichEdit(edf)
   'btn.Show
end sub

sub MenuForm.MakeInsertMenu ()

  dim byref Ins as MenuItem
  dim i as integer, c as integer
  dim byref cinfo as ClassInfo
  c = CtrlList.count
  for i = 0 to c - 1
      set cinfo = CtrlList.Item (i)
      if cinfo.CreateCtrlAddr <> null then
      set ins = new MenuItem ()
      this.mnuInsert.AddItem ( ins )
      ins.Caption = cinfo.Name
      ins.OnClick = subptr ( Ins_Click )
      end if
  next

end sub


sub MenuForm.MenuForm

    with this
        .Caption = "   ForceBasic"
        .OnDestroy = subptr ( MenuForm_OnDestroy )
        .OnPaint = subptr ( MenuForm_OnPaint )
        .OnResize = subptr ( MenuForm_OnResize )

        .Move (100, 50, 800, 650)
        '.Brush.Color = 0xFFFFFF
        .Brush.Color = 0xAAAAAA

        .mnuFile.Additem ( mnuFileNew )
        .mnuFile.Additem ( mnuFileSave )
        .mnuFile.Additem ( mnuFileLoad )

        .mnuForm.AddItem ( mnuFormCodeIt )
        .mnuForm.AddItem ( mnuViewCode )
        .mnuForm.AddItem ( mnuRun )

        .mnuClass.AddItem ( mnuModuleHeader )
        .mnuClass.AddItem ( mnuClassHeader )
        .mnuHelp.AddItem ( mnuHelp1 )

         this.MakeInsertMenu()


        .Menu.AddItem ( mnuFile )
        .Menu.AddItem ( mnuInsert )
        .Menu.AddItem ( mnuForm )
        .Menu.AddItem ( mnuClass )
        .Menu.AddItem ( mnuHelp )




    end with


    mnuFile.Caption = "&"
    mnuInsert.Caption = "&"
    mnuFileNew.Caption = "& ..."
    mnuFileSave.Caption = "& ..."
    mnuFileLoad.Caption = "& ..."
    mnuForm.Caption = "&"
    mnuFormCodeIt.Caption = " ..."
    mnuRun.Caption = "!"
    mnuViewCode.Caption = "  ..."
    mnuClass.Caption = "&"
    mnuModuleHeader.Caption = "  "
    mnuClassHeader.Caption = "  "
    mnuHelp.Caption = "&"
    mnuHelp1.Caption = " FormBuilder..."

    mnuFileSave.OnClick = subptr ( MenuForm_Save )
    mnuFileLoad.OnClick = subptr ( MenuForm_Load )
    mnuFileNew.OnClick = subptr ( MenuForm_New )
    mnuFormCodeIt.OnClick = subptr ( MenuForm_CodeIt )
    mnuRun.OnClick = subptr ( mnuRun_Click )
    mnuViewCode.OnClick = subptr ( mnuViewCode_Click )
    mnuModuleHeader.OnClick = subptr ( mnuMH_Click )
    mnuClassHeader.OnClick = subptr ( mnuCH_Click )

    mnuHelp1.OnClick = subptr ( mnuHelp_Click )



    this.Refresh()
    'this.Visible = 1

end sub

sub MenuForm_New ( byref Menu as MenuItem )

 
  dim byref EF as EditForm
  dim byref w as Widget
  set w = MainForm

  set EF = new EditForm ()
  EF.Parent = w
  EF.Show()


end sub

sub MenuForm_Save ( byref Menu as MenuItem )
if EditedForm <> null then
    dim byref w as MenuForm
    set w = MainForm
    w.OpenSave.ShowSave
    if not (w.OpenSave.FileName = "") then
    dim f as file
    f = fopen (w.OpenSave.FileName, "w+")
    if f <> null then
       dim byref frm as Control
       set frm = EditedForm
       fprint f, frm.StoreControlData ( EventBuilder )
       fprint f, EventsStore.StoreEventData( frm )
       fclose (f)
    end if
    end if
end if
end sub

sub MenuForm_CodeIt ( byref Menu as MenuItem )
if EditedForm <> null then
    dim byref w as MenuForm
    set w = MainForm
    w.OpenSave.ShowSave
    if not (w.OpenSave.FileName = "") then
    dim f as file
    f = fopen (w.OpenSave.FileName, "w+")
    if f <> null then
       dim byref frm as Control
       set frm = EditedForm
       fprint f, frm.TemplateClassCode( EventBuilder )
       fclose (f)
    end if
    end if
end if
end sub

sub Loader ( byref ClassLoader as ClassLoader, byref Control as Control )
   if ref Control <> null then
      'born_components.add ( Control )
   'print Control.ClassName, "\n"
   'doevents

   'dim i as integer
   'for  i = 0 to 10000: next


   'if Control.IsImplement ("Widget") then ' ERROR
   ' dim byref w as Widget
   ' set w = ref Control
   ' if w.IsImplement("Form") then
   '    'SetProp ( w.hWnd, "CustomWndProc", w::WndProc)
   '    'w::WndProc = subptr (Design_WndProcForm)
   '    'w.IsDesigning = true
   '    'w.Visible = true
   '    'w.Refresh()
   ' else
   '    'SetProp ( w.hWnd, "CustomWndProc", w::WndProc)
   '    'w::WndProc = subptr (Design_WndProc)
   '    'w.IsDesigning = true
   ' end if
   'end if
   end if

end sub
 

sub StoreProp ( byref cl as Control, byref Ctrl as Control, byval PropName as string )

      EventsStore.StoreEvent (ctrl, _
                       PropName, _
                       "", _ 
                       "_prop_" )


end sub


sub Loader_LC ( byref Control as Control )
   if ref Control <> null then
   if Control.IsImplement ("Widget") then ' ERROR
    dim byref w as Widget
    set w = ref Control
    if w.IsImplement("Form") then
       SetProp ( w.hWnd, "CustomWndProc", w::WndProc)
       w::WndProc = subptr (Design_WndProcForm)
       w.IsDesigning = true
       w.Visible = true
       w.Refresh()
    else
       SetProp ( w.hWnd, "CustomWndProc", w::WndProc)
       w::WndProc = subptr (Design_WndProc)
       w.IsDesigning = true
    end if
   end if
   end if
end sub

sub Loader_from_LC ()

dim i as integer, c as integer
    c = Loader_Components.Count
    if c > 0 then
       for i = 0 to c - 1

       dim byref ctrl as Control
       set ctrl = Loader_Components.Item ( i )
       Loader_LC ( ctrl )
       next

    end if

    c = Loader_Components_Props.Count
    if c > 0 then
       for i = 0 to c - 1

        dim byref lps as LoaderStoreProperty
        set lps = Loader_Components_Props.Item ( i )
        dim byref ctrl3 as Control
        set ctrl3 = lps.ptr

'print ctrl3.Name, " ", lps.pn, "\n"

      EventsStore.StoreEvent (ctrl3, _
                       lps.pn, _
                       "", _ 
                       "_prop_" )

       next

    end if


end sub


function LoadForm ( byval FileName as string ) as boolean
dim byref ctrl as Control
dim loader as ClassLoader
dim byref Main as MenuForm
'born_components.clear()
dim ret as boolean = false

loader.OnAfterLoad = subptr (Loader)
loader.OnEventLoad = subptr (LoadEvents)
loader.OnStoreProperty = subptr (StoreProp)
set Main = MainForm
'msgbox ">"+FileName+"<"
  set ctrl = loader.CreateControlFromFile (FileName)

  if ref ctrl <> null then
    ret = true
    if NoShow = false then
    ctrl.SetProp ("Visible", "1")
    end if

    if ctrl.IsImplement("Widget") then
       dim byref w as Widget
       dim byref mf as MenuForm
       set mf = MainForm
       set w = ref ctrl
       w.Parent = mf
    if NoShow = false then
       mf.Show()
    end if

       SelControl = ref ctrl
       EditedForm = ref ctrl
    end if
    Loader_from_LC
  else
      msgbox MSG_NOLF
  end if

return = ret
end function

sub MenuForm_Load ( byref Menu as MenuItem )
dim byref ctrl as Control
dim loader as ClassLoader
dim byref Main as MenuForm
loader.OnAfterLoad = subptr (Loader)
loader.OnEventLoad = subptr (LoadEvents)
loader.OnStoreProperty = subptr (StoreProp)
set Main = MainForm
'Main.OpenSave.InitDir = getcwd() 

if Main.OpenSave.ShowOpen then
  set ctrl = loader.CreateControlFromFile (Main.OpenSave.FileName)
  if ref ctrl <> null then
  ctrl.SetProp ("Visible", "1")

  if ctrl.IsImplement("Widget") then
     dim byref w as Widget
     dim byref mf as MenuForm
     set mf = MainForm
     set w = ref ctrl
     w.Parent = mf
     w.OnPaint = subptr (EditForm_OnPaint)
     mf.Show()
     SelControl = ref ctrl
  end if
Loader_from_LC
  else
      msgbox MSG_NOLF
  end if
end if



end sub


sub MenuForm_OnDestroy ( byref Form as Form )
    exit
end sub

sub MenuForm_OnPaint ( byref Form as Form )
    'Form.Canvas.Brush.Color = 10000
    'Form.Canvas.Rectangle (0,0,Form.Width,Form.Height)
end sub

sub MenuForm_OnResize ( byref Form as MenuForm )
    Form.Status.Refresh()
    'Form.Canvas.Brush.Color = 10000
    'Form.Canvas.Rectangle (0,0,Form.Width,Form.Height)
end sub

sub mnuRun_Click ( byref Menu as MenuItem )
f = fopen "~test.bas", "w+"
if EditedForm <> null then
    dim byref w as MenuForm
    set w = MainForm
    if f <> null then
       dim byref frm as Control
       set frm = EditedForm
       fprint f, frm.TemplateClassCode( EventBuilder )
       fprint f, "\n"
       fprint f, "sub main\n"
       fprint f, "  dim TestForm as " + frm.Name + "\n"
       fprint f, "  TestForm.Show\n"
       fprint f, "  loopevents\n"
       fprint f, "end sub\n"
       fprint f, "\n"
       fprint f, "\n"
       fclose (f)
       dim byref mf as Widget
       set mf = MainForm
       mf.Visible = false
       shell "execbas ~test.bas"
       shell "del ~test.bas"
       mf.Visible = true
    end if
end if

end sub

sub mnuViewCode_Click ( byref Menu as MenuItem )
f = fopen "~test.bas", "w+"
if EditedForm <> null then
    dim byref w as MenuForm
    set w = MainForm
    if f <> null then
       dim byref frm as Control
       set frm = EditedForm
       fprint f, frm.TemplateClassCode( EventBuilder )
       fprint f, "\n"
       fclose (f)

       'shell "notepad ~test.bas"

       dim byref mf as Widget
       set mf = MainForm
       mf.Visible = false
       shell "notepad ~test.bas"
       mf.Visible = true
    end if
end if
end sub

sub mnuMH_Click ( byref Menu as MenuItem )


if EditedForm <> null then

   dim byref pf as PropForm
   set pf = Inspector

   dim byref EventI as EventInfo
   dim rs as string = "_ModuleHeaderCode_"
   dim byref ed as EventData
   dim s as string
   s = mid$(rs,3)
 
   set EventI = null

   if EditedForm <> null then

       dim byref ct as Control
       set ct = EditedForm
 
       set ed = EventsStore.GetEvent ( ct, rs )
         'msgbox "f"

       if ref ed = null then

         dim putcode as string
         dim byref ci as ClassInfo
         set ci = classes.GetClassFromName ( ct.ClassName )

         if ref ci <> null then
       
         end if


         'if ref EventI <> null then
            dim rc as string = chr(13) + chr(10)
            putcode = putcode + "' " + rc
         'end if  
         EventsStore.StoreEvent ( ct, rs, putcode, "_ModuleHeaderCode_")
       end if

       set ed = EventsStore.GetEvent ( ct, rs )
       'msgbox str(ref ed)

       if ref ed <> null then

          dim byref ee as EventEdit
          set ee = EventForm
          ee.EvData = ref ed
          'msgbox ed.Text
          ee.Edit.Caption = ed.Text
          ee.Edit.Show

       end if

   end if

end if
end sub

sub mnuHelp_Click ( byref Menu as MenuItem )
    WinExec ("explorer \'doc/FormBuilder.htm\'", 10)
end sub

sub mnuCH_Click ( byref Menu as MenuItem )
if EditedForm <> null then

   dim byref pf as PropForm
   set pf = Inspector

   dim byref EventI as EventInfo
   dim rs as string = "_ModuleClassCode_"
   dim byref ed as EventData
   dim s as string
   s = mid$(rs,3)
 
   set EventI = null

   if EditedForm <> null then

       dim byref ct as Control
       set ct = EditedForm
 
       set ed = EventsStore.GetEvent ( ct, rs )
         'msgbox "f"

       if ref ed = null then

         dim putcode as string
         dim byref ci as ClassInfo
         set ci = classes.GetClassFromName ( ct.ClassName )

         if ref ci <> null then
       
         end if


         'if ref EventI <> null then
            dim rc as string = chr(13) + chr(10)
            putcode = putcode + "'  - , , ,  , , " + rc
         'end if  
         EventsStore.StoreEvent ( ct, rs, putcode, "_ModuleClassCode_")
       end if

       set ed = EventsStore.GetEvent ( ct, rs )
       'msgbox str(ref ed)

       if ref ed <> null then

          dim byref ee as EventEdit
          set ee = EventForm
          ee.EvData = ref ed
          'msgbox ed.Text
          ee.Edit.Caption = ed.Text
          ee.Edit.Show

       end if

   end if

end if

end sub
