'*
'* PropForm
'*
unit User.FormBuilder.PropForm

import windows.gui.*
import User.FormBuilder.EventStore
import User.FormBuilder.Connector
import User.FormBuilder.EditForm

declare sub PropForm_OnPaint ( byref Form as Form )
declare sub Insp_OnResize ( byref PropForm as Widget )
declare sub Class_OnResize ( byref PropForm as Widget )
declare sub Tab_OnChange ( byref PropForm as Widget )
declare sub EventList_OnDblClick ( byref List as ListBox )
declare sub Class_OnClick ( byref PropForm as Widget )
declare sub Node_OnClick ( byref PropForm as TreeView )
declare sub Node_OnKey ( byref PropForm as TreeView, byval key as integer)




declare sub I_OnPropertyChanged ( byref sender as Control, byref ctrl as Control, byref pi as PropertyInfo )


published class ClassForm: implements Form ()

      dim Tree as TreeView ( this )
      dim Btn1 as Button (this)

      sub ClassForm ()

end class

sub ClassForm.ClassForm ()

     with this

         .Move (10, 10, 200, 150)
         .Caption = ""
         .OnResize = subptr ( Class_OnResize )
         .AddWndExStyle (WS_EX_TOOLWINDOW)
          '.Visible = true
         .Tree.BorderStyle = bsSoft
         .Btn1.OnClick = subptr ( Class_OnClick )

         .Btn1.Move (2,2,60,20)
         .Btn1.Caption = ""
         .Btn1.Show ()
         .Tree.OnClick = subptr ( Node_OnClick )
         .Tree.OnKeyPress = subptr ( Node_OnKey )
     end with


end sub



published class PropForm: implements Form ()

      dim Tab as TabControl ( this )
      dim Sheet1 as TabSheet ( this.Tab )
      dim Sheet2 as TabSheet ( this.Tab )
      dim EventList as ListBox ( this.Tab )
      dim Insp as Inspector ( this )

      declare sub RefreshEvents ()

      sub PropForm ()

end class

sub PropForm.PropForm ()

    with this
         .Move (10, 163, 200, 400)
         .Caption = " "
         .OnPaint = subptr ( PropForm_OnPaint )
         '.Visible = true
         .OnResize = subptr ( Insp_OnResize )

         .AddWndExStyle (WS_EX_TOOLWINDOW)
         .Sheet1.Caption = ""
         .Sheet2.Caption = ""
         '.Tab.OnChange = subptr ( Tab_OnChange )
         .Tab.Visible = true
         .Tab.OnChange = subptr ( Tab_OnChange )
         .EventList.OnDblClick = subptr ( EventList_OnDblClick )
         .Insp.OnPropertyChanged = subptr ( I_OnPropertyChanged )
    end with

    with this.Insp
         .Visible = true
         .Move (0,0,this.Width, this.Height)
    end with

    'this.Brush.LogBrush.lbHatch = HS_VERTICAL
    'this.Brush.LogBrush.lbStyle = BS_HATCHED
    'this.Brush.Color = 0xFF00FF

end sub

sub Insp_OnResize ( byref PropForm as PropForm )
'dim byref w as Widget
'set w = Insp.GetParentClass
 PropForm.TAb.Move (0,0,PropForm.ClientWidth,PropForm.ClientHeight)
 PropForm.Insp.Move (3,23,PropForm.Tab.ClientWidth-6,PropForm.Tab.ClientHeight-23)
 PropForm.EventList.Move (3,23,PropForm.Tab.ClientWidth-6,PropForm.Tab.ClientHeight-23)
 PropForm.Insp.Refresh()
 PropForm.EventList.Refresh()
end sub

sub Class_OnResize ( byref CForm as ClassForm )
 CForm.Tree.Move (1,23,CForm.ClientWidth-2,CForm.ClientHeight-25)
end sub


sub Render_Tree ( byref Node as Node, byref ctrl as Control )

dim i as integer, c as integer


    c = ctrl.GetControlCount
    if c > 0 then

       for i = 0 to c-1

           dim byref pc as Control
           set pc = ctrl.GetControl (i)

           if pc.ChildClass = false then
           dim byref nNode as Node
           set nNode = new Node ( Node )
           nNode.Text = pc.Name



           Render_Tree ( nNode, pc )
           end if

       next
   
    end if


end sub

sub Class_OnClick ( byref bTree as Button )
if EditedForm <> null then

   dim byref TreeForm as ClassForm
   set TreeForm = bTree.GetParentClass()
   dim byref Form as Control
   set Form = EditedForm
   TreeForm.Tree.ClearItems
   dim byref nNode as Node
   set nNode = new Node ( TreeForm.Tree.Items )
   nNode.Text = Form.Name
   Render_Tree ( nNode, Form)

end if
end sub

sub Node_OnClick ( byref Tree as TreeView )

if Tree.SelectedItem <> null then
   dim byref Node as Node
   set Node = Tree.Selecteditem


   if EditedForm <> null then

      dim byref cf as Widget
      set cf = EditedForm

      dim byref cc as Control
      set cc = cf.GetControlByName ( Node.Text )

      if ref cc = null then
         if cf.Name = Node.Text then 
            set cc = ref cf
         end if
      end if


      if ref cc <> null then
          SelControl = ref cc


          dim byref pf as PropForm
          set pf = Inspector

          pf.Insp.ControlRef = SelControl
          pf.RefreshEvents()

'         msgbox cc.Name



      end if

   end if

end if

end sub

sub Tab_OnChange ( byref Tab as TabControl )

dim byref p as PropForm
set p = Tab.GetParentClass()
if ref p <> null then

   if Tab.TabIndex = 0 then
      P.EventList.Visible = false
      P.Insp.Visible = true
      P.Insp.Refresh()
   end if
   if Tab.TabIndex = 1 then
      P.Insp.Visible = false
      P.EventList.Visible = true
      P.EventList.Refresh()
   end if

end if
end sub

sub PropForm_OnPaint ( byref Form as Form )
end sub


sub PropForm.RefreshEvents ()
if this.Insp.ControlRef <> null then

   dim byref ci as ClassInfo
   dim byref ctrl as Control

   set ctrl = this.Insp.ControlRef
   set ci = classes.GetClassFromName ( ctrl.ClassName )
   if ref ci <> null then

       dim byref Col as Collection
       set Col = new Collection ()

       ci.GetEventsInfo ( ctrl.ClassName, Col )
       this.EventList.Clear
       if Col.Count > 0 then

          dim i as integer, c as integer
          c = Col.Count
          for i = 0 to c - 1

              dim byref ei as Eventinfo
              set ei = Col.Item (i)
              dim s as string

              if EventsStore.GetEvent ( ctrl, ei.Name ) <> null then

                 s = " + " + ei.Name 

              else

                 s = "   " + ei.Name

              end if


              this.EventList.AddItem ( s )


          next


       end if
        

'       msgbox str ( Col.Count )


       delete Col

   end if


end if
end sub


sub EventList_OnDblClick ( byref List as ListBox )
if List.ListIndex <> -1 then
   dim byref Tab as Control
   set Tab = List.GetParentClass()
   dim byref pf as PropForm
   set pf = Tab.GetParentClass()

   dim byref EventI as EventInfo
   dim rs as string = List.List ( List.ListIndex )
   dim byref ed as EventData
   dim s as string
   s = mid$(rs,3)
 
   set EventI = null

   if pf.Insp.ControlRef <> null then

       dim byref ct as Control
       set ct = pf.Insp.ControlRef
 
       set ed = EventsStore.GetEvent ( ct, s )
       if ref ed = null then


         dim putcode as string
         dim byref ci as ClassInfo
         set ci = classes.GetClassFromName ( ct.ClassName )
         if ref ci <> null then

             dim byref ncol as Collection
             set nCol = new Collection()

             ci.GetEventsInfo ( ct.ClassName ,nCol )
             dim i as integer, c as integer
             c = nCol.count
             if c > 0 then
                for  i = 0 to c-1
                   dim byref ei as EventInfo
                   set ei = nCol.Item (i)
                   if ref ei <> null then
 
                     if lcase(ei.Name) = lcase(s) then
                         set EventI = ref ei
                      end if
                   end if
                next
             end if

             delete nCol
        
         end if


         if ref EventI <> null then
            dim rc as string = chr(13) + chr(10)
            
            n1 = instr (0,lcase(EventI.DeclareText), "event", 0, false )
            n2 = instr (n1 + 6,lcase(EventI.DeclareText), "(", 0, false )
            n3 = instr (n2 + 1,lcase(EventI.DeclareText), ",", 0, false )
            
            if n3 = -1 then
               putcode = "sub " + ct.Name + "_" + s + " ( byref Sender as Control " +  mid(EventI.DeclareText,n2+1)
            else
               putcode = "sub " + ct.Name + "_" + s + " ( byref Sender as Control, " +  mid(EventI.DeclareText,n2+1)
            end if

            putcode = putcode + rc + "   'Put code here" + rc + "end sub" + rc
         end if  

         EventsStore.StoreEvent ( ct, s, putcode, ct.Name + "_" + s)
       end if
       set ed = EventsStore.GetEvent ( ct, s )
       'msgbox str(ref ed)

       if ref ed <> null then

          dim byref ee as EventEdit
          set ee = EventForm
          ee.EvData = ref ed

          'msgbox ed.Text

          ee.Edit.Caption = ed.Text
          ee.Edit.Show
          ee.Active()
       end if

   end if

end if

end sub


sub Node_OnKey ( byref PropForm as TreeView, byval key as integer)

if key = 46 then
if SelControl <> null then
'msgbox "DEL!"

   dim byref ctrl as Control
   set ctrl = SelControl
   SelControl = null

   if ctrl.isImplement ("Form") = false then
   'ctrl.~Control ()
     delete ctrl
     dim byref cf as ClassForm
     set cf = pubClassForm
     cf.Btn1.OnClick ()
   end if

end if
end if

end sub


sub I_OnPropertyChanged ( byref sender as Inspector, byref ctrl as Control, byref pi as PropertyInfo )
      EventsStore.StoreEvent (ctrl, _
                       pi.Name, _
                       "", _ 
                       "_prop_" )
'msgbox pi.Name


end sub








